searchData={"items":[{"type":"task","title":"mix sentry.install","doc":"Installs sentry. Requires igniter to be installed.\n\nThis installer is built with, and requires, igniter to be used. Igniter is a tool\nfor biulding package installers. For information on how to add igniter to your\nproject, see the documentation https://hexdocs.pm/igniter/readme.html#installation.","ref":"Mix.Tasks.Sentry.Install.html"},{"type":"task","title":"Example - mix sentry.install","doc":"```bash\nmix sentry.install --dsn  \n```","ref":"Mix.Tasks.Sentry.Install.html#module-example"},{"type":"task","title":"Options - mix sentry.install","doc":"* `--dsn` - Your Sentry DSN.","ref":"Mix.Tasks.Sentry.Install.html#module-options"},{"type":"task","title":"mix sentry.package_source_code","doc":"Packages source code for Sentry to use when reporting errors.\n\nThis task should be used in production settings, before building a release of your\napplication. It packages all the source code of your application in a single file\n(called `sentry.map`), which is optimized for fast retrieval of source code lines.\nSentry then uses this to report source code context. See the documentation for the\n`Sentry` module for configuration options related to the source code context.\n\n*This task is available since v10.0.0 of this library*.","ref":"Mix.Tasks.Sentry.PackageSourceCode.html"},{"type":"task","title":"Usage - mix sentry.package_source_code","doc":"```shell\nmix sentry.package_source_code\n```","ref":"Mix.Tasks.Sentry.PackageSourceCode.html#module-usage"},{"type":"task","title":"Using in Production - mix sentry.package_source_code","doc":"In production settings, call this task before building a release. This way, the source\ncode packaged by this task will be included in the release.\n\nFor example, in a release script (this could also be in a `Dockerfile`, if you're using\nDocker):\n\n```shell\n# ...\n\nmix sentry.package_source_code\nmix release\n```\n\n> #### Runtime Configuration {: .tip}\n>\n> If you use `config/runtime.exs` for runtime configuration of your application and\n> release, *and* you also configure the source-context-related options for the `:sentry`\n> application in that file (such as `:root_source_code_paths`), you'll need to call the\n> `mix app.config` task before calling this Mix task. `mix app.config` loads the\n> `config/runtime.exs` configuration. Generally, we recommend configuring all the\n> source-context-related options in compile-time config files (like `config/config.exs`\n> or `config/prod.exs`).","ref":"Mix.Tasks.Sentry.PackageSourceCode.html#module-using-in-production"},{"type":"task","title":"Options - mix sentry.package_source_code","doc":"* `--debug` - print more information about collecting and encoding source code\n  * `--output PATH` - write source map file to the given `PATH`. If you don't specify\n    this option, the file will be written to the default path, which is inside the `priv`\n    directory of the `:sentry` application. If you use this option, remember to also\n    **configure the `:source_code_map_path` option**, otherwise Sentry will try to\n    *read* the file from the default location. See `Sentry` for more information.\n    This option can be useful when the source\n    `priv` directory is read-only, such as with [NixOS](https://github.com/NixOS/nixpkgs)\n    and similar tools.\n    *Available since v10.2.0*.\n  * `--no-compile` - does not compile applications before running\n  * `--no-deps-check` - does not check dependencies before running","ref":"Mix.Tasks.Sentry.PackageSourceCode.html#module-options"},{"type":"task","title":"mix sentry.send_test_event","doc":"Sends a test event to Sentry to check if your Sentry configuration is correct.\n\nThis task reports a `RuntimeError` exception like this one:\n\n    %RuntimeError{message: \"Testing sending Sentry event\"}","ref":"Mix.Tasks.Sentry.SendTestEvent.html"},{"type":"task","title":"Options - mix sentry.send_test_event","doc":"* `--no-compile` - does not compile, even if files require compilation.\n  * `--type` - `exception` or `message`. Defaults to `exception`. *Available since v10.1.0.*.\n  * `--no-stacktrace` - does not include a stacktrace in the reported event. *Available since\n    v10.1.0.*.","ref":"Mix.Tasks.Sentry.SendTestEvent.html#module-options"},{"type":"module","title":"SamplingContext","doc":"The struct for the **sampling_context** that is passed to `traces_sampler`.\n\nThis is set up via `Sentry.OpenTelemetry.Sampler`.\n\nSee also  .","ref":"SamplingContext.html"},{"type":"type","title":"SamplingContext.t/0","doc":"The sampling context struct that contains information needed for sampling decisions.\n\nThis matches the structure used in the Python SDK's create_sampling_context function.","ref":"SamplingContext.html#t:t/0"},{"type":"module","title":"Sentry","doc":"Provides the functionality to submit events to [Sentry](https://sentry.io).\n\nThis library can be used to submit events to Sentry from any Elixir application.\nIt supports several ways of reporting events:\n\n  * Manually — see `capture_exception/2` and `capture_message/2`.\n\n  * Through an [Erlang `:logger`](https://www.erlang.org/doc/apps/kernel/logger.html) handler —\n    see `Sentry.LoggerHandler`.\n\n  * Through an Elixir `Logger` backend — see `Sentry.LoggerBackend`.\n\n  * Automatically for Plug/Phoenix applications — see the\n    [*Setup with Plug and Phoenix* guide](setup-with-plug-and-phoenix.html), and the\n    `Sentry.PlugCapture` and `Sentry.PlugContext` modules.\n\n  * Through integrations for various ecosystem tools, like [Oban](oban-integration.html)\n    or [Quantum](quantum-integration.html).","ref":"Sentry.html"},{"type":"module","title":"Usage - Sentry","doc":"Add the following to your production configuration:\n\n    # In config/prod.exs\n    config :sentry, dsn: \"https://public:secret@app.getsentry.com/1\",\n      environment_name: :prod,\n      tags: %{\n        env: \"production\"\n      }\n\nSentry uses the `:dsn` option to determine whether it should record exceptions. If\n`:dsn` is set, then Sentry records exceptions. If it's not set or set to `nil`,\nthen simply no events are sent to Sentry.\n\n> #### Included Environments {: .warning}\n>\n> Before v10.0.0, the recommended way to control whether to report events to Sentry\n> was the `:included_environments` option (a list of environments to report events for).\n> This was used together with the `:environment_name` option to determine whether to\n> send events. `:included_environments` is deprecated in v10.0.0 in favor of setting\n> or not setting `:dsn`. It will be removed in v11.0.0.\n\nYou can even rely on more specific logic to determine the environment name. It's\nnot uncommon for most applications to have a \"staging\" environment. In order\nto handle this without adding an additional Mix environment, you can set an\nenvironment variable that determines the release level. By default, Sentry\npicks up the `SENTRY_ENVIRONMENT` variable (*at runtime, when starting*).\nOtherwise, you can read the variable at runtime. Do this only in\n`config/runtime.exs` so that it will work both for local development as well\nas Mix releases.\n\n    # In config/runtime.exs\n    if config_env() == :prod do\n      config :sentry, dsn: \"https://public:secret@app.getsentry.com/1\",\n        environment_name: System.fetch_env!(\"RELEASE_LEVEL\")\n    end\n\nIn this example, we are getting the environment name from the `RELEASE_LEVEL`\nenvironment variable. Now, on our servers, we can set the environment variable\nappropriately. The `config_env() == :prod` check ensures that we only set\n`:dsn` in production, effectively only enabling reporting in production-like\nenvironments.\n\nSentry supports many configuration options. See the [*Configuration*\nsection](#module-configuration) for complete documentation.","ref":"Sentry.html#module-usage"},{"type":"module","title":"Configuration - Sentry","doc":"*See also the [official Sentry\ndocumentation](https://docs.sentry.io/platforms/elixir/configuration/).*\n\nYou can configure Sentry through the application environment, under the `:sentry` application.\nFor example, you can do this in `config/config.exs`:\n\n    # config/config.exs\n    config :sentry,\n      # ...\n\n**Sentry reads the configuration when the `:sentry` application starts**, and\nwill not pick up any changes after that. This is in line with how other\nSentry SDKs (and many other Erlang/Elixir libraries) work. The reason\nfor this choice is performance: the SDK performs validation on application\nstart and then caches the configuration (in [`:persistent_term`](`:persistent_term`)).\n\n> #### Updating Configuration at Runtime {: .tip}\n>\n> If you *must* update configuration at runtime, use `put_config/2`. This\n> function is not efficient (since it updates terms in `:persistent_term`),\n> but it works in a pinch. For example, it's useful if you're verifying\n> that you send the right events to Sentry in your test suite, so you need to\n> change the `:dsn` configuration to point to a local server that you can verify\n> requests on.\n\nBelow you can find all the available configuration options.\n\n#### Basic Options\n\n* `:dsn` (`t:String.t/0` or `nil`) - The DSN for your Sentry project. If this is not set, Sentry will not be enabled.\n  If the `SENTRY_DSN` environment variable is set, it will be used as the default value.\n  If `:test_mode` is `true`, the `:dsn` option is sometimes ignored; see `Sentry.Test`\n  for more information. The default value is `nil`.\n\n* `:environment_name` (`t:String.t/0` or `t:atom/0`) - The current environment name. This is used to specify the environment\n  that an event happened in. It can be any string shorter than 64 bytes,\n  except the string `\"None\"`. When Sentry receives an event with an environment,\n  it creates that environment if it doesn't exist yet.\n  If the `SENTRY_ENVIRONMENT` environment variable is set, it will\n  be used as the value for this option. The default value is `\"production\"`.\n\n* `:traces_sample_rate` - The sample rate for transaction events. A value between `0.0` and `1.0` (inclusive).\n  A value of `0.0` means no transactions will be sampled, while `1.0` means all transactions\n  will be sampled.\n\n  This value is also used to determine if tracing is enabled: if it's not `nil`, tracing is enabled.\n\n  Tracing requires OpenTelemetry packages to work. See [the\n  OpenTelemetry setup documentation](https://opentelemetry.io/docs/languages/erlang/getting-started/)\n  for guides on how to set it up.\n\n  The default value is `nil`.\n\n* `:traces_sampler` (`t:traces_sampler_function/0` or `nil`) - A function that determines the sample rate for transaction events. This function\n  receives a sampling context struct and should return a boolean or a float between `0.0` and `1.0`.\n\n  The sampling context contains:\n  - `:parent_sampled` - boolean indicating if the parent trace span was sampled (nil if no parent)\n  - `:transaction_context` - map with transaction information (name, op, etc.)\n\n  If both `:traces_sampler` and `:traces_sample_rate` are configured, `:traces_sampler` takes precedence.\n\n  Example:\n  ```elixir\n  traces_sampler: fn sampling_context ->\n    case sampling_context.transaction_context.op do\n      \"http.server\" -> 0.1  # Sample 10% of HTTP requests\n      \"db.query\" -> 0.01    # Sample 1% of database queries\n      _ -> false            # Don't sample other operations\n    end\n  end\n  ```\n\n  This value is also used to determine if tracing is enabled: if it's not `nil`, tracing is enabled.\n\n  The default value is `nil`.\n\n* `:included_environments` (list of `t:atom/0` or `t:String.t/0`, or the atom `:all`) - *This option is deprecated. Use :dsn to control whether to send events to Sentry.* **Deprecated**. The environments in which Sentry can report events. If this is a list,\n  then `:environment_name` needs to be in this list for events to be reported.\n  If this is `:all`, then Sentry will report events regardless of the value\n  of `:environment_name`. *This will be removed in v11.0.0*.\n\n* `:release` (`t:String.t/0` or `nil`) - The release version of your application.\n  This is used to correlate events with source code. If the `SENTRY_RELEASE`\n  environment variable is set, it will be used as the default value. The default value is `nil`.\n\n* `:json_library` (`t:module/0`) - A module that implements the \"standard\" Elixir JSON behaviour, that is, exports the\n  `encode/1` and `decode/1` functions.\n\n  Defaults to `Jason` if the `JSON` kernel module is not available (it was introduced\n  in Elixir 1.18.0). If you use the default configuration with Elixir version lower than\n  1.18, this option will default to `Jason`, but you will have to add\n  [`:jason`](https://hexa.pm/packages/jason) as a dependency of your application.\n\n  The default value is `Jason`.\n\n* `:send_client_reports` (`t:boolean/0`) - Send diagnostic client reports about discarded events, interval is set to send a report\n  once every 30 seconds if any discarded events exist.\n  See [Client Reports](https://develop.sentry.dev/sdk/client-reports/) in Sentry docs.\n  *Available since v10.8.0*. The default value is `true`.\n\n* `:server_name` (`t:String.t/0`) - The name of the server running the application. Not used by default.\n\n* `:sample_rate` (`t:float/0`) - The percentage of events to send to Sentry. A value of `0.0` will deny sending any events,\n  and a value of `1.0` will send 100% of events. Sampling is applied\n  **after** the `:before_send` callback. See where [the Sentry\n  documentation](https://develop.sentry.dev/sdk/sessions/#filter-order)\n  suggests this. Must be between `0.0` and `1.0` (included). The default value is `1.0`.\n\n* `:tags` (map of `t:term/0` keys and `t:term/0` values) - A map of tags to be sent with every event. The default value is `%{}`.\n\n* `:extra` (`t:Sentry.Context.extra/0`) - A map of extra data to be sent with every event. The default value is `%{}`.\n\n* `:max_breadcrumbs` (`t:non_neg_integer/0`) - The maximum number of breadcrumbs to keep. See `Sentry.Context.add_breadcrumb/1`. The default value is `100`.\n\n* `:report_deps` (`t:boolean/0`) - Whether to report application dependencies of your application\n  alongside events. This list contains applications (alongside their version)\n  that are **loaded** when the `:sentry` application starts. The default value is `true`.\n\n* `:log_level` - The level to use when Sentry fails to\n  send an event due to an API failure or other reasons. The default value is `:warning`.\n\n* `:filter` (`t:module/0`) - A module that implements the `Sentry.EventFilter`\n  behaviour. Defaults to `Sentry.DefaultEventFilter`. See the\n  [*Filtering Exceptions* section](#module-filtering-exceptions) below. The default value is `Sentry.DefaultEventFilter`.\n\n* `:dedup_events` (`t:boolean/0`) - Whether to **deduplicate** events before reporting them to Sentry. If this option is `true`,\n  then the SDK will store reported events for around 30 seconds after they're reported.\n  Any time the SDK is about to report an event, it will check if it has already reported\n  within the past 30 seconds. If it has, then it will not report the event again, and will\n  log a message instead. Events are deduplicated by comparing their message, exception,\n  stacktrace, and fingerprint. *Available since v10.0.0*. The default value is `true`.\n\n* `:test_mode` (`t:boolean/0`) - Whether to enable *test mode*. When test mode is enabled, the SDK will check whether\n  there is a process **collecting events** and avoid sending those events if that's the\n  case. This is useful for testing—see `Sentry.Test`. `:test_mode` works in tandem\n  with `:dsn`; this is described in detail in `Sentry.Test`. The default value is `false`.\n\n* `:integrations` (`t:keyword/0`) - Configuration for integrations with third-party libraries. Every integration has its own\n  option and corresponding configuration options. The default value is `[]`.\n\n  * `:max_expected_check_in_time` (`t:integer/0`) - The time in milliseconds that a check-in ID will live after it has been created.\n\n    The SDK reports the start and end of each check-in. A check-in is used to track the\n    progress of a specific check-in event associated with cron job telemetry events that are a part\n    of the same job. However, to optimize performance and prevent potential memory issues,\n    if a check-in end event is reported after the specified `max_expected_check_in_time`,\n    the SDK will not report it. This behavior helps manage resource usage effectively while still\n    providing necessary tracking for your jobs.\n    *Available since 10.6.3*.\n\n    The default value is `600000`.\n\n  * `:monitor_config_defaults` (`t:keyword/0`) - Defaults to be used for the `monitor_config` when reporting cron jobs with one of the\n    integrations. This supports all the keys defined in the [Sentry\n    documentation](https://develop.sentry.dev/sdk/telemetry/check-ins/#monitor-upsert-support).\n    See also `Sentry.CheckIn.new/1`. *Available since v10.8.0*. The default value is `[]`.\n\n  * `:oban` (`t:keyword/0`) - Configuration for the [Oban](https://github.com/sorentwo/oban) integration. The Oban\n    integration requires at minumum Oban Pro v0.14 or Oban v.2.17.6. *Available\n    since v10.2.0*.\n\n    * `:capture_errors` (`t:boolean/0`) - Whether to capture errors from Oban jobs. When enabled, the Sentry SDK will capture\n      errors that happen in Oban jobs, including when errors return `{:error, reason}`\n      tuples. *Available since 10.3.0*. The default value is `false`.\n\n    * `:cron` (`t:keyword/0`) - Configuration options for configuring [*crons*](https://docs.sentry.io/product/crons/)\n      for Oban.\n\n      * `:enabled` (`t:boolean/0`) - Whether to enable the Oban integration. When enabled, the Sentry SDK will\n        capture check-ins for Oban jobs. *Available since v10.2.0*. The default value is `false`.\n\n      * `:monitor_slug_generator` (`{module(), atom()}`) - A `{module, function}` tuple that generates a monitor name based on the `Oban.Job` struct.\n        The function is called with the `Oban.Job` as its arguments and must return a string.\n        This can be used to customize monitor slugs. *Available since v10.8.0*.\n\n  * `:quantum` (`t:keyword/0`) - Configuration for the [Quantum](https://github.com/quantum-elixir/quantum-core) integration.\n    *Available since v10.2.0*.\n\n    * `:cron` (`t:keyword/0`) - Configuration options for configuring [*crons*](https://docs.sentry.io/product/crons/)\n      for Quantum.\n\n      * `:enabled` (`t:boolean/0`) - Whether to enable the Quantum integration. When enabled, the Sentry SDK will\n        capture check-ins for Quantum jobs. *Available since v10.2.0*. The default value is `false`.\n\n  * `:telemetry` (`t:keyword/0`) - Configuration for the [Telemetry](https://hexdocs.pm/telemetry) integration.\n    *Available since v10.10.0*.\n\n    * `:report_handler_failures` (`t:boolean/0`) - Whether to report failures (to Sentry) that happen in telemetry handlers. These failures\n      result in the handlers being detached, so capturing them in Sentry can be useful\n      to detect and fix these issues as soon as possible. The default value is `false`.\n\n\n\n#### Hook Options\n\nThese options control hooks that this SDK can call before or after sending events.\n\n* `:before_send` (`t:before_send_event_callback/0`) - Allows performing operations on the event *before* it is sent as\n  well as filtering out the event altogether.\n  If the callback returns `nil` or `false`, the event is not reported. If it returns an\n  updated `Sentry.Event`, then the updated event is used instead. See the [*Event Callbacks*\n  section](#module-event-callbacks) below for more information.\n\n  `:before_send` is available *since v10.0.0*. Before, it was called `:before_send_event`.\n\n* `:before_send_event` (`t:before_send_event_callback/0`) - *This option is deprecated. Use :before_send instead.* Exactly the same as `:before_send`, but has been **deprecated since v10.0.0**.\n\n* `:after_send_event` (`t:after_send_event_callback/0`) - Callback that is called *after*\n  attempting to send an event. The result of the HTTP call as well as the event will\n  be passed as arguments. The return value of the callback is not returned. See the\n  [*Event Callbacks* section](#module-event-callbacks) below for more information.\n\n\n\n#### Transport Options\n\nThese options control how this Sentry SDK sends events to the Sentry server.\n\n* `:send_result` (`t:send_type/0`) - Controls what to return when reporting exceptions to Sentry. The default value is `:none`.\n\n* `:client` (`t:module/0`) - A module that implements the `Sentry.HTTPClient`\n  behaviour. Defaults to `Sentry.HackneyClient`, which uses\n  [hackney](https://github.com/benoitc/hackney) as the HTTP client. The default value is `Sentry.HackneyClient`.\n\n* `:send_max_attempts` (`t:pos_integer/0`) - The maximum number of attempts to send an event to Sentry. The default value is `4`.\n\n* `:hackney_opts` (`t:keyword/0`) - Options to be passed to `hackney`. Only\n  applied if `:client` is set to `Sentry.HackneyClient`. The default value is `[pool: :sentry_pool]`.\n\n* `:hackney_pool_timeout` (`t:timeout/0`) - The maximum time to wait for a\n  connection to become available. Only applied if `:client` is set to\n  `Sentry.HackneyClient`. The default value is `5000`.\n\n* `:hackney_pool_max_connections` (`t:pos_integer/0`) - The maximum number of\n  connections to keep in the pool. Only applied if `:client` is set to\n  `Sentry.HackneyClient`. The default value is `50`.\n\n\n\n#### Source Code Context Options\n\nThese options control how source code context is reported alongside events.\n\n* `:enable_source_code_context` (`t:boolean/0`) - Whether to report source code context alongside events. The default value is `false`.\n\n* `:root_source_code_paths` (list of `t:Path.t/0`) - A list of paths to the root of\n  your application's source code. This is used to determine the relative\n  path of files in stack traces. Usually, you'll want to set this to\n  `[File.cwd!()]`. For umbrella apps, you should set this to all the application\n  paths in your umbrella (such as `[Path.join(File.cwd!(), \"apps/app1\"), ...]`).\n  **Required** if `:enabled_source_code_context` is `true`. The default value is `[]`.\n\n* `:source_code_path_pattern` (`t:String.t/0`) - A glob pattern used to\n  determine which files to report source code context for. The glob \"starts\"\n  from `:root_source_code_paths`. The default value is `\"**/*.ex\"`.\n\n* `:source_code_exclude_patterns` (list of `t:Regex.t/0`) - A list of regular expressions used to determine which files to\n  exclude from source code context.\n\n* `:source_code_map_path` (`t:Path.t/0`) - The path to the source code map file. See\n  [`mix sentry.package_source_code`](`Mix.Tasks.Sentry.PackageSourceCode`).\n  Defaults to a private path inside Sentry's `priv` directory. *Available since v10.2.0*.\n\n* `:context_lines` (`t:pos_integer/0`) - The number of lines of source code\n  before and after the line that caused the exception to report. The default value is `3`.\n\n* `:in_app_otp_apps` (list of `t:atom/0`) - A list of OTP application names that will be used to populate additional modules for the\n  `:in_app_module_allow_list` option. List your application (or the applications in your\n  umbrella project) for them to show as \"in-app\" in stacktraces in Sentry. We recommend using\n  this option over `:in_app_module_allow_list`, unless you need more control over the exact\n  modules to consider as \"in-app\".\n\n  *Available since v10.9.0*.\n\n  The default value is `[]`.\n\n* `:in_app_module_allow_list` (list of `t:module/0`) - A list of modules that is used\n  to distinguish among stacktrace frames that belong to your app and ones that are\n  part of libraries or core Elixir. This is used to better display the significant part\n  of stacktraces. The logic is \"greedy\", so if your app's root module is `MyApp` and\n  you configure this option to `[MyApp]`, `MyApp` as well as any submodules\n  (like `MyApp.Submodule`) would be considered part of your app.\n\n  Usually, the `:in_app_otp_apps` option should be preferred as it's\n  simpler to work with.\n\n  The default value is `[]`.\n\n\n\n\n> #### Configuration Through System Environment {: .info}\n>\n> Sentry supports loading some configuration from the system environment.\n> The supported environment variables are: `SENTRY_RELEASE`, `SENTRY_ENVIRONMENT`,\n> and `SENTRY_DSN`. See the `:release`, `:environment_name`, and `:dsn` configuration\n> options respectively for more information.","ref":"Sentry.html#module-configuration"},{"type":"module","title":"Filtering Exceptions - Sentry","doc":"If you would like to prevent Sentry from sending certain exceptions, you can\nuse the `:before_send` configuration option. See the [*Event Callbacks*\nsection](#module-event-callbacks) below.\n\nBefore v9.0.0, the recommended way to filter out exceptions was to use a *filter*,\nthat is, a module implementing the `Sentry.EventFilter` behaviour. This is still supported,\nbut is now deprecated. See `Sentry.EventFilter` for more information.","ref":"Sentry.html#module-filtering-exceptions"},{"type":"module","title":"Event Callbacks - Sentry","doc":"You can configure the `:before_send` and `:after_send_event` options to\ncustomize what happens before and/or after sending an event. The `:before_send`\ncallback must be of type `t:before_send_event_callback/0` and the `:after_send_event`\ncallback must be of type `t:after_send_event_callback/0`. For example, you\ncan set:\n\n    config :sentry,\n      before_send: {MyModule, :before_send},\n      after_send_event: {MyModule, :after_send}\n\n`MyModule` could look like this:\n\n    defmodule MyModule do\n      def before_send(event) do\n        metadata = Map.new(Logger.metadata())\n        %Sentry.Event{event | extra: Map.merge(event.extra, metadata)}\n      end\n\n      def after_send_event(event, result) do\n        case result do\n          {:ok, id} ->\n            Logger.info(\"Successfully sent event!\")\n\n          {:error, _reason} ->\n            Logger.info(fn -> \"Did not successfully send event! #{inspect(event)}\" end)\n        end\n      end\n    end","ref":"Sentry.html#module-event-callbacks"},{"type":"module","title":"Reporting Source Code - Sentry","doc":"Sentry supports reporting the source code of (and around) the line that\ncaused an issue. An example configuration to enable this functionality is:\n\n    config :sentry,\n      dsn: \"https://public:secret@app.getsentry.com/1\",\n      enable_source_code_context: true,\n      root_source_code_paths: [File.cwd!()],\n      context_lines: 5\n\nTo support this functionality, Sentry needs to **package** source code\nand store it so that it's available in the compiled application. Packaging source\ncode is an active step you have to take; use the [`mix\nsentry.package_source_code`](`Mix.Tasks.Sentry.PackageSourceCode`) Mix task to do that.\n\nSentry stores the packaged source code in its `priv` directory. This is included by\ndefault in [Mix releases](`Mix.Tasks.Release`). Once the source code is packaged\nand ready to ship with your release, Sentry will load it when the `:sentry` application\nstarts. If there are issues with loading the packaged code, Sentry will log some warnings\nbut will boot up normally and it just won't report source code context.\n\n> #### Prune Large File Trees {: .tip}\n>\n> Due to Sentry reading the file system and defaulting to a recursive search\n> of directories, it is important to check your configuration and compilation\n> environment to avoid a folder recursion issue. You might see problems when\n> deploying to the root folder, so it is best to follow the practice of\n> compiling your application in its own folder. Modifying the\n> `:source_code_path_pattern` configuration option from its default is also\n> an avenue to avoid compile problems, as well as pruning unnecessary files\n> with `:source_code_exclude_patterns`.","ref":"Sentry.html#module-reporting-source-code"},{"type":"function","title":"Sentry.capture_check_in/1","doc":"Captures a check-in built with the given `options`.\n\nCheck-ins are used to report the status of a monitor to Sentry. This is used\nto track the health and progress of **cron jobs**. This function is somewhat\nlow level, and mostly useful when you want to report the status of a cron\nbut you are not using any common library to manage your cron jobs.\n\nThis function performs a *synchronous* HTTP request to Sentry. If the request\nperforms successfully, it returns `{:ok, check_in_id}` where `check_in_id` is\nthe ID of the check-in that was sent to Sentry. You can use this ID to send\nupdates about the same check-in. If the request fails, it returns\n`{:error, reason}`.\n\n> #### Setting the DSN {: .warning}\n>\n> If the `:dsn` configuration is not set, this function won't report the check-in\n> to Sentry and will instead return `:ignored`. This behaviour is consistent with\n> the rest of the SDK (such as `capture_exception/2`).","ref":"Sentry.html#capture_check_in/1"},{"type":"function","title":"Examples - Sentry.capture_check_in/1","doc":"Say you have a GenServer which periodically sends a message to itself to execute some\njob. You could monitor the health of this GenServer by reporting a check-in to Sentry.\n\nFor example:\n\n    @impl GenServer\n    def handle_info(:execute_periodic_job, state) do\n      # Report that the job started.\n      {:ok, check_in_id} = Sentry.capture_check_in(status: :in_progress, monitor_slug: \"genserver-job\")\n\n      :ok = do_job(state)\n\n      # Report that the job ended successfully.\n      Sentry.capture_check_in(check_in_id: check_in_id, status: :ok, monitor_slug: \"genserver-job\")\n\n      {:noreply, state}\n    end","ref":"Sentry.html#capture_check_in/1-examples"},{"type":"function","title":"Sentry.capture_exception/2","doc":"Parses and submits an exception to Sentry.\n\nThis only sends the exception if the `:dsn` configuration option is set\nand is not `nil`. See the [*Configuration* section](#module-configuration)\nin the module documentation.","ref":"Sentry.html#capture_exception/2"},{"type":"function","title":"Options - Sentry.capture_exception/2","doc":"* `:after_send_event` (`t:after_send_event_callback/0`) - Same as the global `:after_send_event` configuration, but\n  applied only to this call. See the module documentation. *Available since v10.0.0*.\n\n* `:before_send` (`t:before_send_event_callback/0`) - Same as the global `:before_send` configuration, but\n  applied only to this call. See the module documentation. *Available since v10.0.0*.\n\n* `:breadcrumbs` (list of `t:keyword/0` or `t:Sentry.Context.breadcrumb/0`) - List of breadcrumbs. This list gets **prepended** to the list\n  in the context (see `Sentry.Context.add_breadcrumb/1`). The default value is `[]`.\n\n* `:client` (`t:module/0`) - Same as the global `:client` configuration, but\n  applied only to this call. See the module documentation. *Available since v10.0.0*.\n\n* `:event_source` (`t:atom/0`) - The source of the event. This fills in the `:source` field of the\n  returned struct. This is not present by default.\n\n* `:extra` (`t:Sentry.Context.extra/0`) - Map of extra context, which gets merged with the current context\n  (see `Sentry.Context.set_extra_context/1`). If fields collide, the ones\n  in the map passed through this option have precedence over the ones in\n  the context. The default value is `%{}`.\n\n* `:fingerprint` (list of `t:String.t/0`) - List of the fingerprint for grouping this event. The default value is `[\"{{ default }}\"]`.\n\n* `:interpolation_parameters` (list of `t:term/0`) - The parameters to use for message interpolation. This is only used if the\n  `:message` option is present. This is not present by default. See\n  `Sentry.capture_message/2`. *Available since v10.1.0*.\n\n* `:level` (`t:level/0`) - The level of the event. The default value is `:error`.\n\n* `:message` (`t:String.t/0`) - A message to report. The string can contain interpolation markers (`%s`). In that\n  case, you can pass the `:interpolation_parameters` option as well to fill\n  in those parameters. See `Sentry.capture_message/2` for more information on\n  message interpolation. Not present by default.\n\n* `:request` (`t:Sentry.Context.request_context/0`) - Map of request context, which gets merged with the current context\n  (see `Sentry.Context.set_request_context/1`). If fields collide, the ones\n  in the map passed through this option have precedence over the ones in\n  the context. The default value is `%{}`.\n\n* `:result` - Allows specifying how the result should be returned. The possible values are:\n\n  * `:sync` - Sentry will make an API call synchronously (including retries) and will\n    return `{:ok, event_id}` if successful.\n\n  * `:none` - Sentry will send the event in the background, in a *fire-and-forget*\n    fashion. The function will return `{:ok, \"\"}` regardless of whether the API\n    call ends up being successful or not.\n\n* `:sample_rate` (`t:float/0`) - Same as the global `:sample_rate` configuration, but applied only to\n  this call. See the module documentation. *Available since v10.0.0*.\n\n* `:stacktrace` (`t:Exception.stacktrace/0`) - The exception's stacktrace. This can also be used with messages (`:message`). Not\n  present by default.\n\n* `:tags` (`t:Sentry.Context.tags/0`) - Map of tags context, which gets merged with the current context (see\n  `Sentry.Context.set_tags_context/1`) and with the `:tags` option in the global\n  Sentry configuration. If fields collide, the ones in the map passed through\n  this option have precedence over the ones in the context, which have precedence\n  over the ones in the configuration. The default value is `%{}`.\n\n* `:user` (`t:Sentry.Context.user_context/0`) - Map of user context, which gets merged with the current context\n  (see `Sentry.Context.set_user_context/1`). If fields collide, the ones\n  in the map passed through this option have precedence over the ones in\n  the context. The default value is `%{}`.","ref":"Sentry.html#capture_exception/2-options"},{"type":"function","title":"Sentry.capture_message/2","doc":"Reports a message to Sentry.","ref":"Sentry.html#capture_message/2"},{"type":"function","title":"Options - Sentry.capture_message/2","doc":"* `:after_send_event` (`t:after_send_event_callback/0`) - Same as the global `:after_send_event` configuration, but\n  applied only to this call. See the module documentation. *Available since v10.0.0*.\n\n* `:before_send` (`t:before_send_event_callback/0`) - Same as the global `:before_send` configuration, but\n  applied only to this call. See the module documentation. *Available since v10.0.0*.\n\n* `:breadcrumbs` (list of `t:keyword/0` or `t:Sentry.Context.breadcrumb/0`) - List of breadcrumbs. This list gets **prepended** to the list\n  in the context (see `Sentry.Context.add_breadcrumb/1`). The default value is `[]`.\n\n* `:client` (`t:module/0`) - Same as the global `:client` configuration, but\n  applied only to this call. See the module documentation. *Available since v10.0.0*.\n\n* `:event_source` (`t:atom/0`) - The source of the event. This fills in the `:source` field of the\n  returned struct. This is not present by default.\n\n* `:exception` (`t:Exception.t/0`) - This is the exception that gets reported in the\n  `:exception` field of `t:Sentry.Event.t/0`. The term passed here also ends up unchanged in\n  the `:original_exception` field of `t:Sentry.Event.t/0`. This option is **required** unless\n  the `:message` option is present. Not present by default.\n\n* `:extra` (`t:Sentry.Context.extra/0`) - Map of extra context, which gets merged with the current context\n  (see `Sentry.Context.set_extra_context/1`). If fields collide, the ones\n  in the map passed through this option have precedence over the ones in\n  the context. The default value is `%{}`.\n\n* `:fingerprint` (list of `t:String.t/0`) - List of the fingerprint for grouping this event. The default value is `[\"{{ default }}\"]`.\n\n* `:interpolation_parameters` (list of `t:term/0`) - The parameters to use for message interpolation. This is only used if the\n  `:message` option is present. This is not present by default. See\n  `Sentry.capture_message/2`. *Available since v10.1.0*.\n\n* `:level` (`t:level/0`) - The level of the event. The default value is `:error`.\n\n* `:request` (`t:Sentry.Context.request_context/0`) - Map of request context, which gets merged with the current context\n  (see `Sentry.Context.set_request_context/1`). If fields collide, the ones\n  in the map passed through this option have precedence over the ones in\n  the context. The default value is `%{}`.\n\n* `:result` - Allows specifying how the result should be returned. The possible values are:\n\n  * `:sync` - Sentry will make an API call synchronously (including retries) and will\n    return `{:ok, event_id}` if successful.\n\n  * `:none` - Sentry will send the event in the background, in a *fire-and-forget*\n    fashion. The function will return `{:ok, \"\"}` regardless of whether the API\n    call ends up being successful or not.\n\n* `:sample_rate` (`t:float/0`) - Same as the global `:sample_rate` configuration, but applied only to\n  this call. See the module documentation. *Available since v10.0.0*.\n\n* `:stacktrace` (`t:Exception.stacktrace/0`) - The exception's stacktrace. This can also be used with messages (`:message`). Not\n  present by default.\n\n* `:tags` (`t:Sentry.Context.tags/0`) - Map of tags context, which gets merged with the current context (see\n  `Sentry.Context.set_tags_context/1`) and with the `:tags` option in the global\n  Sentry configuration. If fields collide, the ones in the map passed through\n  this option have precedence over the ones in the context, which have precedence\n  over the ones in the configuration. The default value is `%{}`.\n\n* `:user` (`t:Sentry.Context.user_context/0`) - Map of user context, which gets merged with the current context\n  (see `Sentry.Context.set_user_context/1`). If fields collide, the ones\n  in the map passed through this option have precedence over the ones in\n  the context. The default value is `%{}`.","ref":"Sentry.html#capture_message/2-options"},{"type":"function","title":"Interpolation (since v10.1.0) - Sentry.capture_message/2","doc":"The `message` argument supports interpolation. You can pass a string with formatting\nmarkers as `%s`, and then pass in the `:interpolation_parameters` option as a list\nof positional parameters to interpolate. For example:\n\n    Sentry.capture_message(\"Error with user %s\", interpolation_parameters: [\"John\"])\n\nThis way, Sentry will group the messages based on the non-interpolated string, but it\nwill show the interpolated string in the UI.\n\n> #### Missing or Extra Parameters {: .neutral}\n>\n> If the message string has more `%s` markers than parameters, the extra `%s` markers\n> are included as is and the SDK doesn't raise any error. If you pass in more interpolation\n> parameters than `%s` markers, the extra parameters are ignored as well. This is because\n> the SDK doesn't want to be the cause of even more errors in your application when what\n> you're trying to do is report an error in the first place.","ref":"Sentry.html#capture_message/2-interpolation-since-v10-1-0"},{"type":"function","title":"Sentry.get_dsn/0","doc":"Returns the currently-set Sentry DSN, *if set* (or `nil` otherwise).\n\nThis is useful in situations like capturing user feedback.","ref":"Sentry.html#get_dsn/0"},{"type":"function","title":"Sentry.get_last_event_id_and_source/0","doc":"Gets the last event ID sent to the server from the process dictionary.\nSince it uses the process dictionary, it will only return the last event\nID sent within the current process.","ref":"Sentry.html#get_last_event_id_and_source/0"},{"type":"function","title":"Sentry.put_config/2","doc":"Updates the value of `key` in the configuration *at runtime*.\n\nOnce the `:sentry` application starts, it validates and caches the value of the\nconfiguration options you start it with. Because of this, updating configuration\nat runtime requires this function as opposed to just changing the application\nenvironment.\n\n> #### This Function Is Slow {: .warning}\n>\n> This function updates terms in [`:persistent_term`](`:persistent_term`), which is what\n> this SDK uses to cache configuration. Updating terms in `:persistent_term` is slow\n> and can trigger full GC sweeps. We recommend only using this function in rare cases,\n> or during tests.","ref":"Sentry.html#put_config/2"},{"type":"function","title":"Examples - Sentry.put_config/2","doc":"For example, if you're using [`Bypass`](https://github.com/PSPDFKit-labs/bypass) to test\nthat you send the correct events to Sentry:\n\n    test \"reports the correct event to Sentry\" do\n      bypass = Bypass.open()\n\n      Bypass.expect(...)\n\n      Sentry.put_config(:dsn, \"http://public:secret@localhost:#{bypass.port}/1\")\n      Sentry.put_config(:send_result, :sync)\n\n      my_function_to_test()\n    end","ref":"Sentry.html#put_config/2-examples"},{"type":"function","title":"Sentry.put_last_event_id_and_source/2","doc":"Puts the last event ID sent to the server for the current process in\nthe process dictionary.","ref":"Sentry.html#put_last_event_id_and_source/2"},{"type":"function","title":"Sentry.send_event/2","doc":"Sends an event to Sentry.\n\nAn **event** is the most generic payload you can send to Sentry. It encapsulates\ninformation about an exception, a message, or any other event that you want to\nreport. To manually build events, see the functions in `Sentry.Event`.\n\nThis function doesn't build the event for you, it only *sends* it. Most of the time,\nyou'll want to use `capture_exception/2` or `capture_message/2`. To manually create events,\nsee `Sentry.Event.create_event/1`.","ref":"Sentry.html#send_event/2"},{"type":"function","title":"Options - Sentry.send_event/2","doc":"* `:result` - Allows specifying how the result should be returned. The possible values are:\n\n  * `:sync` - Sentry will make an API call synchronously (including retries) and will\n    return `{:ok, event_id}` if successful.\n\n  * `:none` - Sentry will send the event in the background, in a *fire-and-forget*\n    fashion. The function will return `{:ok, \"\"}` regardless of whether the API\n    call ends up being successful or not.\n\n* `:client` (`t:module/0`) - Same as the global `:client` configuration, but\n  applied only to this call. See the module documentation. *Available since v10.0.0*.\n\n* `:sample_rate` (`t:float/0`) - Same as the global `:sample_rate` configuration, but applied only to\n  this call. See the module documentation. *Available since v10.0.0*.\n\n* `:before_send` (`t:before_send_event_callback/0`) - Same as the global `:before_send` configuration, but\n  applied only to this call. See the module documentation. *Available since v10.0.0*.\n\n* `:after_send_event` (`t:after_send_event_callback/0`) - Same as the global `:after_send_event` configuration, but\n  applied only to this call. See the module documentation. *Available since v10.0.0*.\n\n\n\n> #### Async Send {: .error}\n>\n> Before v9.0.0 of this library, the `:result` option also supported the `:async` value.\n> This would spawn a `Task` to make the API call, and would return a `{:ok, Task.t()}` tuple.\n> You could use `Task` operations to wait for the result asynchronously. Since v9.0.0, this\n> option is not present anymore. Instead, you can spawn a task yourself that then calls this\n> function with `result: :sync`. The effect is exactly the same.\n\n> #### Sending Exceptions and Messages {: .tip}\n>\n> This function is **low-level**, and mostly intended for library developers,\n> or folks that want to have full control on what they report to Sentry. For most\n> use cases, use `capture_exception/2` or `capture_message/2`.","ref":"Sentry.html#send_event/2-options"},{"type":"function","title":"Sentry.send_transaction/2","doc":"","ref":"Sentry.html#send_transaction/2"},{"type":"type","title":"Sentry.after_send_event_callback/0","doc":"A callback to use with the `:after_send_event` configuration option.\n\nIf this is `{module, function_name}`, then `module.function_name(event, result)` will\nbe called, where `event` is of type `t:Sentry.Event.t/0`.","ref":"Sentry.html#t:after_send_event_callback/0"},{"type":"type","title":"Sentry.before_send_event_callback/0","doc":"A callback to use with the `:before_send` configuration option.\nconfiguration options.k\n\nIf this is `{module, function_name}`, then `module.function_name(event)` will\nbe called, where `event` is of type `t:Sentry.Event.t/0`.\n\nSee the [*Configuration* section](#module-configuration) in the module documentation\nfor more information on configuration.","ref":"Sentry.html#t:before_send_event_callback/0"},{"type":"type","title":"Sentry.send_result/0","doc":"","ref":"Sentry.html#t:send_result/0"},{"type":"type","title":"Sentry.send_type/0","doc":"The strategy to use when sending an event to Sentry.","ref":"Sentry.html#t:send_type/0"},{"type":"module","title":"Sentry.Context","doc":"Provides functionality to store user, tags, extra, and breadcrumbs context when an\nevent is reported.\n\nThe contexts will be fetched and merged into the event when it is sent.\n\n`Sentry.Context` uses Elixir `Logger` metadata to store the context itself.\nThis imposes some limitations. The metadata will only exist **within\nthe current process**, and the context will disappear when the process\ndies. For example, if you add context inside your controller and an\nerror happens in a spawned `Task`, that context will not be included.\n\nA common use case is to set context when handling requests within Plug or Phoenix\napplications, as each request is its own process, and so any stored context is included\nshould an error be reported within that request process. For example:\n\n    # post_controller.ex\n    def index(conn, _params) do\n      Sentry.Context.set_user_context(%{id: conn.assigns.user_id})\n      posts = Blog.list_posts()\n      render(conn, \"index.html\", posts: posts)\n    end\n\n> #### Merging {: .info}\n>\n> The `set_*_context/1` functions **merge** with the\n> existing context rather than entirely overwriting it.","ref":"Sentry.Context.html"},{"type":"module","title":"Sentry Documentation - Sentry.Context","doc":"Sentry itself documents the meaning of the various contexts:\n\n  * [General context interface](https://develop.sentry.dev/sdk/event-payloads/contexts/)\n  * [Breadcrumbs interface](https://develop.sentry.dev/sdk/event-payloads/breadcrumbs/)\n  * [Request context](https://develop.sentry.dev/sdk/event-payloads/request/)\n  * [User context](https://develop.sentry.dev/sdk/event-payloads/user/)","ref":"Sentry.Context.html#module-sentry-documentation"},{"type":"function","title":"Sentry.Context.add_attachment/1","doc":"Adds an **attachment** to the current context.\n\nAttachments stored in the context will be sent alongside each event that is\nreported *within that context* (that is, within the process that the context\nwas set in).\n\nCurrently, there is no limit to how many attachments you can add to the context\nthrough this function, even though there might be limits on the Sentry server side.\nTo clear attachments, use `clear_attachments/0`.","ref":"Sentry.Context.html#add_attachment/1"},{"type":"function","title":"Examples - Sentry.Context.add_attachment/1","doc":"iex> Sentry.Context.add_attachment(%Sentry.Attachment{filename: \"foo.txt\", data: \"foo\"})\n    :ok\n    iex> Sentry.Context.add_attachment(%Sentry.Attachment{filename: \"bar.txt\", data: \"bar\"})\n    :ok\n    iex> Sentry.Context.get_all()\n    %{\n      attachments: [\n        %Sentry.Attachment{filename: \"bar.txt\", data: \"bar\"},\n        %Sentry.Attachment{filename: \"foo.txt\", data: \"foo\"}\n      ],\n      breadcrumbs: [],\n      extra: %{},\n      request: %{},\n      tags: %{},\n      user: %{}\n    }","ref":"Sentry.Context.html#add_attachment/1-examples"},{"type":"function","title":"Sentry.Context.add_breadcrumb/1","doc":"Adds a new breadcrumb to the `:breadcrumb` context, specific to the current\nprocess.\n\nBreadcrumbs are used to record a series of events that led to a specific\ninstance of an error. Breadcrumbs can contain arbitrary key data to assist in\nunderstanding what happened before an error occurred.\n\nSee the [Sentry documentation](https://develop.sentry.dev/sdk/event-payloads/breadcrumbs/)\nfor more information.\n\nIf `breadcrumb_info` is a keyword list, it should be convertible to a map of type\n`t:breadcrumb/0`.\n\nIf not present, the `:timestamp` key is filled in automatically with the current\nUnix timestamp (in seconds).","ref":"Sentry.Context.html#add_breadcrumb/1"},{"type":"function","title":"Example - Sentry.Context.add_breadcrumb/1","doc":"iex> Sentry.Context.add_breadcrumb(message: \"first_event\")\n    :ok\n    iex> Sentry.Context.add_breadcrumb(%{message: \"second_event\", type: \"auth\"})\n    %{breadcrumbs: [%{:message => \"first_event\", \"timestamp\" => 1562007480}]}\n    iex> Sentry.Context.add_breadcrumb(%{message: \"response\"})\n    %{\n      breadcrumbs: [\n        %{:message => \"second_event\", :type => \"auth\", \"timestamp\" => 1562007505},\n        %{:message => \"first_event\", \"timestamp\" => 1562007480}\n      ]\n    }\n    iex> Sentry.Context.get_all()\n    %{\n      attachments: [],\n      breadcrumbs: [\n        %{:message => \"first_event\", \"timestamp\" => 1562007480},\n        %{:message => \"second_event\", :type => \"auth\", \"timestamp\" => 1562007505},\n        %{:message => \"response\", \"timestamp\" => 1562007517}\n      ],\n      extra: %{},\n      request: %{},\n      tags: %{},\n      user: %{}\n    }","ref":"Sentry.Context.html#add_breadcrumb/1-example"},{"type":"function","title":"Sentry.Context.clear_all/0","doc":"Clears all existing context for the current process.","ref":"Sentry.Context.html#clear_all/0"},{"type":"function","title":"Example - Sentry.Context.clear_all/0","doc":"iex> Sentry.Context.set_tags_context(%{id: 123})\n    :ok\n    iex> Sentry.Context.clear_all()\n    :ok\n    iex> Sentry.Context.get_all()\n    %{breadcrumbs: [], extra: %{}, request: %{}, tags: %{}, user: %{}, attachments: []}","ref":"Sentry.Context.html#clear_all/0-example"},{"type":"function","title":"Sentry.Context.clear_attachments/0","doc":"Clears all attachments from the current context.\n\nSee `add_attachment/1`.","ref":"Sentry.Context.html#clear_attachments/0"},{"type":"function","title":"Examples - Sentry.Context.clear_attachments/0","doc":"iex> Sentry.Context.add_attachment(%Sentry.Attachment{filename: \"foo.txt\", data: \"foo\"})\n    :ok\n    iex> Sentry.Context.clear_attachments()\n    :ok\n    iex> Sentry.Context.get_all().attachments\n    []","ref":"Sentry.Context.html#clear_attachments/0-examples"},{"type":"function","title":"Sentry.Context.context_keys/0","doc":"Returns the keys used to store context in the current process' logger metadata.","ref":"Sentry.Context.html#context_keys/0"},{"type":"function","title":"Example - Sentry.Context.context_keys/0","doc":"iex> Sentry.Context.context_keys()\n    [:breadcrumbs, :tags, :user, :extra, :request, :attachments]","ref":"Sentry.Context.html#context_keys/0-example"},{"type":"function","title":"Sentry.Context.get_all/0","doc":"Retrieves all currently-set context on the current process.","ref":"Sentry.Context.html#get_all/0"},{"type":"function","title":"Example - Sentry.Context.get_all/0","doc":"iex> Sentry.Context.set_user_context(%{id: 123})\n    iex> Sentry.Context.set_tags_context(%{message_id: 456})\n    iex> Sentry.Context.get_all()\n    %{\n      user: %{id: 123},\n      tags: %{message_id: 456},\n      extra: %{},\n      request: %{},\n      breadcrumbs: [],\n      attachments: []\n    }","ref":"Sentry.Context.html#get_all/0-example"},{"type":"function","title":"Sentry.Context.set_extra_context/1","doc":"Merges new fields into the `:extra` context, specific to the current process.\n\nThis is used to set fields which should display when looking at a specific\ninstance of an error.","ref":"Sentry.Context.html#set_extra_context/1"},{"type":"function","title":"Example - Sentry.Context.set_extra_context/1","doc":"iex> Sentry.Context.set_extra_context(%{id: 123})\n    :ok\n    iex> Sentry.Context.set_extra_context(%{detail: \"bad_error\"})\n    :ok\n    iex> Sentry.Context.set_extra_context(%{message: \"Oh no\"})\n    :ok\n    iex> Sentry.Context.get_all()\n    %{\n      user: %{},\n      tags: %{},\n      extra: %{detail: \"bad_error\", id: 123, message: \"Oh no\"},\n      request: %{},\n      breadcrumbs: [],\n      attachments: []\n    }","ref":"Sentry.Context.html#set_extra_context/1-example"},{"type":"function","title":"Sentry.Context.set_request_context/1","doc":"Merges new fields into the `:request` context, specific to the current\nprocess.\n\nThis is used to set metadata that identifies the request associated with a\nspecific instance of an error.\n\nThe request context is documented [in the Sentry\ndocumentation](https://develop.sentry.dev/sdk/event-payloads/request/).\n\n> #### Invalid Keys {: .error}\n>\n> While this function accepts any map with atom keys, the only keys that\n> are valid are those in `t:request_context/0`. We don't validate\n> keys because of performance concerns, so it's up to you to ensure that\n> you're passing valid keys.","ref":"Sentry.Context.html#set_request_context/1"},{"type":"function","title":"Example - Sentry.Context.set_request_context/1","doc":"iex> Sentry.Context.set_request_context(%{url: \"example.com\"})\n    :ok\n    iex> headers = %{\"accept\" => \"application/json\"}\n    iex> Sentry.Context.set_request_context(%{headers: headers, method: \"GET\"})\n    :ok\n    iex> Sentry.Context.get_all()\n    %{\n        attachments: [],\n        breadcrumbs: [],\n        extra: %{},\n        request: %{method: \"GET\", headers: %{\"accept\" => \"application/json\"}, url: \"example.com\"},\n        tags: %{},\n        user: %{}\n    }","ref":"Sentry.Context.html#set_request_context/1-example"},{"type":"function","title":"Sentry.Context.set_tags_context/1","doc":"Merges new fields into the `:tags` context, specific to the current process.\n\nThis is used to set fields which should display when looking at a specific\ninstance of an error. These fields can also be used to search and filter on.","ref":"Sentry.Context.html#set_tags_context/1"},{"type":"function","title":"Example - Sentry.Context.set_tags_context/1","doc":"iex> Sentry.Context.set_tags_context(%{id: 123})\n    :ok\n    iex> Sentry.Context.set_tags_context(%{other_id: 456})\n    :ok\n    iex> Sentry.Context.get_all()\n    %{\n        attachments: [],\n        breadcrumbs: [],\n        extra: %{},\n        request: %{},\n        tags: %{id: 123, other_id: 456},\n        user: %{}\n    }","ref":"Sentry.Context.html#set_tags_context/1-example"},{"type":"function","title":"Sentry.Context.set_user_context/1","doc":"Merges new fields into the `:user` context, specific to the current process.\n\nThis is used to set certain fields which identify the actor who experienced a\nspecific instance of an error.\n\nThe user context is documented [in the Sentry\ndocumentation](https://develop.sentry.dev/sdk/event-payloads/user/).\n\n> #### Additional Keys {: .error}\n>\n> While at least one of the keys described in `t:Sentry.Interfaces.user/0` is\n> recommended, you can also add any arbitrary key to the user context.","ref":"Sentry.Context.html#set_user_context/1"},{"type":"function","title":"Example - Sentry.Context.set_user_context/1","doc":"iex> Sentry.Context.set_user_context(%{id: 123})\n    :ok\n    iex> Sentry.Context.set_user_context(%{username: \"george\"})\n    :ok\n    iex> Sentry.Context.get_all()\n    %{\n      user: %{id: 123, username: \"george\"},\n      tags: %{},\n      extra: %{},\n      request: %{},\n      breadcrumbs: [],\n      attachments: []\n    }","ref":"Sentry.Context.html#set_user_context/1-example"},{"type":"type","title":"Sentry.Context.breadcrumb/0","doc":"Breadcrumb info.\n\nSee `add_breadcrumb/1`.","ref":"Sentry.Context.html#t:breadcrumb/0"},{"type":"type","title":"Example - Sentry.Context.breadcrumb/0","doc":"%{\n      type: \"default\",\n      category: \"ui.click\",\n      data: nil,\n      level: \"info\",\n      message: \"User clicked on the main button\",\n      timestamp: 1596814007.035\n    }","ref":"Sentry.Context.html#t:breadcrumb/0-example"},{"type":"type","title":"Sentry.Context.extra/0","doc":"A map of **extra** data.\n\nSee `set_extra_context/1`.","ref":"Sentry.Context.html#t:extra/0"},{"type":"type","title":"Sentry.Context.request_context/0","doc":"Request context.\n\nSee `set_request_context/1`. This map gets eventually converted\ninto a `Sentry.Interfaces.Request` struct.","ref":"Sentry.Context.html#t:request_context/0"},{"type":"type","title":"Sentry.Context.tags/0","doc":"A map of **tags**.\n\nSee `set_tags_context/1`.","ref":"Sentry.Context.html#t:tags/0"},{"type":"type","title":"Sentry.Context.user_context/0","doc":"User context.\n\nSee `set_user_context/1`.\n\nYou can use `\"{{auto}}\"` as the value of `:ip_address` to let Sentry infer the\nIP address (see [the documentation for automatic IP\naddresses](https://develop.sentry.dev/sdk/event-payloads/user/#automatic-ip-addresses)).\n\nOther than the keys specified in the typespec below, all other keys are stored\nas extra information but not specifically processed by Sentry.","ref":"Sentry.Context.html#t:user_context/0"},{"type":"type","title":"Example - Sentry.Context.user_context/0","doc":"%{\n      user: %{\n        id: \"unique_id\",\n        username: \"my_user\",\n        email: \"foo@example.com\",\n        ip_address: \"127.0.0.1\",\n\n        # Extra key\n        subscription: \"basic\"\n      }\n    }","ref":"Sentry.Context.html#t:user_context/0-example"},{"type":"module","title":"Sentry.DefaultEventFilter","doc":"The default implementation of the `Sentry.EventFilter` behaviour.\n\nThis filter excludes the following exceptions:\n\n  * `Phoenix.NotAcceptableError`\n  * `Phoenix.Router.NoRouteError`\n  * `Plug.Conn.InvalidQueryError`\n  * `Plug.Parsers.BadEncodingError`\n  * `Plug.Parsers.ParseError`\n  * `Plug.Parsers.RequestTooLargeError`\n  * `Plug.Parsers.UnsupportedMediaTypeError`\n  * `Plug.Static.InvalidPathError`\n\nIn addition, it excludes routes that do not match in plug routers.","ref":"Sentry.DefaultEventFilter.html"},{"type":"module","title":"Sentry.Event","doc":"Provides functions to create Sentry events from scratch, from exceptions, and so on.\n\nThis module also contains the main event struct. Events are the fundamental data\nthat clients send to the Sentry server.\n\nSee  .","ref":"Sentry.Event.html"},{"type":"function","title":"Sentry.Event.__struct__/0","doc":"The struct representing the event.\n\nYou're not advised to manipulate this struct's fields directly. Instead,\nuse functions such as `create_event/1` or `transform_exception/2` for creating\nevents.\n\nSee the `t:t/0` type for information on the fields and their types.","ref":"Sentry.Event.html#__struct__/0"},{"type":"function","title":"Sentry.Event.create_event/1","doc":"Creates an event struct out of collected context and options.\n\n> #### Merging Options with Context and Config {: .info}\n>\n> Some of the options documented below are **merged** with the Sentry context, or\n> with the Sentry context *and* the configuration. The option you pass here always\n> has higher precedence, followed by the context and finally by the configuration.\n>\n> See also `Sentry.Context` for information on the Sentry context and `Sentry` for\n> information on configuration.","ref":"Sentry.Event.html#create_event/1"},{"type":"function","title":"Options - Sentry.Event.create_event/1","doc":"* `:exception` (`t:Exception.t/0`) - This is the exception that gets reported in the\n  `:exception` field of `t:Sentry.Event.t/0`. The term passed here also ends up unchanged in\n  the `:original_exception` field of `t:Sentry.Event.t/0`. This option is **required** unless\n  the `:message` option is present. Not present by default.\n\n* `:stacktrace` (`t:Exception.stacktrace/0`) - The exception's stacktrace. This can also be used with messages (`:message`). Not\n  present by default.\n\n* `:message` (`t:String.t/0`) - A message to report. The string can contain interpolation markers (`%s`). In that\n  case, you can pass the `:interpolation_parameters` option as well to fill\n  in those parameters. See `Sentry.capture_message/2` for more information on\n  message interpolation. Not present by default.\n\n* `:extra` (`t:Sentry.Context.extra/0`) - Map of extra context, which gets merged with the current context\n  (see `Sentry.Context.set_extra_context/1`). If fields collide, the ones\n  in the map passed through this option have precedence over the ones in\n  the context. The default value is `%{}`.\n\n* `:user` (`t:Sentry.Context.user_context/0`) - Map of user context, which gets merged with the current context\n  (see `Sentry.Context.set_user_context/1`). If fields collide, the ones\n  in the map passed through this option have precedence over the ones in\n  the context. The default value is `%{}`.\n\n* `:tags` (`t:Sentry.Context.tags/0`) - Map of tags context, which gets merged with the current context (see\n  `Sentry.Context.set_tags_context/1`) and with the `:tags` option in the global\n  Sentry configuration. If fields collide, the ones in the map passed through\n  this option have precedence over the ones in the context, which have precedence\n  over the ones in the configuration. The default value is `%{}`.\n\n* `:request` (`t:Sentry.Context.request_context/0`) - Map of request context, which gets merged with the current context\n  (see `Sentry.Context.set_request_context/1`). If fields collide, the ones\n  in the map passed through this option have precedence over the ones in\n  the context. The default value is `%{}`.\n\n* `:breadcrumbs` (list of `t:keyword/0` or `t:Sentry.Context.breadcrumb/0`) - List of breadcrumbs. This list gets **prepended** to the list\n  in the context (see `Sentry.Context.add_breadcrumb/1`). The default value is `[]`.\n\n* `:level` (`t:level/0`) - The level of the event. The default value is `:error`.\n\n* `:fingerprint` (list of `t:String.t/0`) - List of the fingerprint for grouping this event. The default value is `[\"{{ default }}\"]`.\n\n* `:event_source` (`t:atom/0`) - The source of the event. This fills in the `:source` field of the\n  returned struct. This is not present by default.\n\n* `:interpolation_parameters` (list of `t:term/0`) - The parameters to use for message interpolation. This is only used if the\n  `:message` option is present. This is not present by default. See\n  `Sentry.capture_message/2`. *Available since v10.1.0*.","ref":"Sentry.Event.html#create_event/1-options"},{"type":"function","title":"Examples - Sentry.Event.create_event/1","doc":"iex> event = create_event(exception: %RuntimeError{message: \"oops\"}, level: :warning)\n    iex> event.level\n    :warning\n    iex> hd(event.exception).type\n    \"RuntimeError\"\n    iex> event.original_exception\n    %RuntimeError{message: \"oops\"}\n\n    iex> event = create_event(message: \"Unknown route\", event_source: :plug)\n    iex> event.source\n    :plug","ref":"Sentry.Event.html#create_event/1-examples"},{"type":"function","title":"Sentry.Event.transform_exception/2","doc":"Transforms an exception to a Sentry event.\n\nThis essentially defers to `create_event/1`.","ref":"Sentry.Event.html#transform_exception/2"},{"type":"function","title":"Options - Sentry.Event.transform_exception/2","doc":"This function takes the same options as `create_event/1`, except for the `:exception` option.","ref":"Sentry.Event.html#transform_exception/2-options"},{"type":"type","title":"Sentry.Event.level/0","doc":"The level of an event.","ref":"Sentry.Event.html#t:level/0"},{"type":"type","title":"Sentry.Event.t/0","doc":"The type for the event struct.\n\nAll of the fields in this struct map directly to the fields described in the\n[Sentry documentation](https://develop.sentry.dev/sdk/event-payloads). These fields\nare the exceptions, and are specific to the Elixir Sentry SDK:\n\n  * `:source` - the source of the event. `Sentry.LoggerBackend` and `Sentry.LoggerHandler`\n    set this to `:logger`, while `Sentry.PlugCapture` and `Sentry.PlugContext` set it to\n    `:plug`. You can set it to any atom. See the `:event_source` option in `create_event/1`\n    and `transform_exception/2`.\n\n  * `:original_exception` - the original exception that is being reported, if there's one.\n    The Elixir Sentry SDK manipulates reported exceptions to make them fit the payload\n    required by the Sentry API, and these end up in the `:exception` field. The\n    `:original_exception` field, instead, contains the original exception as the raw Elixir\n    term (such as `%RuntimeError{...}`).\n\n  * `:integration_meta` - a free-form map of integration-specific metadata. Integrations\n    (such as [the Oban integration](https://docs.sentry.io/platforms/elixir/integrations/oban/))\n    can set this field to store metadata that\n    is specific to the integration. This field is not part of the Sentry API payload,\n    but you can use it for example in [`:before_send`\n    callbacks](`t:Sentry.before_send_event_callback/0`) to determine whether to report events.\n    *Available since v10.7.0*.\n\nSee also [`%Sentry.Event{}`](`__struct__/0`).","ref":"Sentry.Event.html#t:t/0"},{"type":"behaviour","title":"Sentry.EventFilter","doc":"A behaviour for filtering events to send to Sentry.\n\nThere's only one callback to implement, `c:exclude_exception?/2`.\n\n> #### Soft-deprecated {: .warning}\n>\n> This behaviour is soft-deprecated in favor of filtering events through the\n> `:before_send` callback functionality. `:before_send` is described in\n> details in the documentation for the `Sentry` module. It's a more general\n> mechanism to filter or modify events before sending them to Sentry. See below for\n> an example of how to replace an event filter with a `:before_send` callback.\n>\n> In future major versions of this library, we might hard-deprecate or remove this\n> behaviour altogether.","ref":"Sentry.EventFilter.html"},{"type":"behaviour","title":"Usage - Sentry.EventFilter","doc":"To use a custom event filter module, configure the `:filter` option\nin the `:sentry` application. For example:\n\n    config :sentry,\n      filter: MyApp.SentryEventFilter\n\nThe default event filter is `Sentry.DefaultEventFilter`.","ref":"Sentry.EventFilter.html#module-usage"},{"type":"behaviour","title":"Examples - Sentry.EventFilter","doc":"As an example, if you wanted to exclude all `ArithmeticError` exceptions\nand nothing else:\n\n    defmodule MyApp.SentryEventFilter do\n      @behaviour Sentry.EventFilter\n\n      @impl true\n      def exclude_exception?(%ArithmeticError{}, _source), do: true\n      def exclude_exception?(_exception, _source), do: false\n    end\n\nAlternatively, if you wanted to skip all non-500 exceptions in a Plug app:\n\n    defmodule MyApp.SentryEventFilter do\n      @behaviour Sentry.EventFilter\n\n      @impl true\n      def exclude_exception?(exception, _source) do\n        Plug.Exception.status(exception) < 500\n      end\n    end\n\nIf you want to exclude some specific exceptions but then fall back to the\ndefault event filter, you can do something like this:\n\n    defmodule MyApp.SentryEventFilter do\n      @behaviour Sentry.EventFilter\n\n      @impl true\n      def exclude_exception?(%ArithmeticError{}, _source) do\n        true\n      end\n\n      def exclude_exception?(exception, source) do\n        Sentry.DefaultEventFilter.exclude_exception?(exception, source)\n      end\n    end","ref":"Sentry.EventFilter.html#module-examples"},{"type":"behaviour","title":"Replacing With `:before_send` - Sentry.EventFilter","doc":"Let's look at an example of how to filter non-500 exceptions in a Plug app through\nthe `:before_send` callback. We can start with a module:\n\n    defmodule MyApp.SentryEventFilter do\n      def filter_non_500(%Sentry.Event{original_exception: exception} = event) do\n        cond do\n          Plug.Exception.status(exception) < 500 ->\n            false\n\n          # Fall back to the default event filter.\n          Sentry.DefaultEventFilter.exclude_exception?(exception, event.source) ->\n            false\n\n          true ->\n            event\n        end\n      end\n    end\n\nThen, we can configure the `:before_send` callback.\n\n    config :sentry,\n      before_send: {MyApp.SentryEventFilter, :filter_non_500}\n\n> #### Multiple Callbacks {: .tip}\n>\n> You can only have one `:before_send` callback. If you change the value\n> of this configuration option, you'll *override* the previous callback. If you\n> want to do multiple things in a `:before_send` callback, create a function\n> that does all the things you need and register *that* as the callback.","ref":"Sentry.EventFilter.html#module-replacing-with-before_send"},{"type":"callback","title":"Sentry.EventFilter.exclude_exception?/2","doc":"Should return whether the given event should be *excluded* from being\nreported to Sentry.\n\n`exception` is the exception that was raised.\n\n`source` is the source of the event. Events from `Sentry.PlugCapture`\nwill have `:plug` as a source and events from `Sentry.LoggerBackend`\nwill have `:logger` as the source. A custom source can also be specified\nby passing the `:event_source` option to `Sentry.capture_exception/2`.","ref":"Sentry.EventFilter.html#c:exclude_exception?/2"},{"type":"behaviour","title":"Sentry.Integrations.Oban.Cron","doc":"This module provides built-in integration for cron jobs managed by Oban.","ref":"Sentry.Integrations.Oban.Cron.html"},{"type":"callback","title":"Sentry.Integrations.Oban.Cron.sentry_check_in_configuration/1","doc":"The Oban integration calls this callback (if present) to customize\nthe configuration options for the check-in.\n\nThis function must return options compatible with the ones passed to `Sentry.CheckIn.new/1`.\n\nOptions returned by this function overwrite any option inferred by the specific\nintegration for the check in. We perform *deep merging* of nested keyword options.","ref":"Sentry.Integrations.Oban.Cron.html#c:sentry_check_in_configuration/1"},{"type":"module","title":"Sentry.Integrations.Telemetry","doc":"Sentry integration for Telemetry.\n\n*Available since v10.10.0*.","ref":"Sentry.Integrations.Telemetry.html"},{"type":"module","title":"Sentry.Transaction","doc":"The struct for the **transaction** interface.\n\nSee  .","ref":"Sentry.Transaction.html"},{"type":"type","title":"Sentry.Transaction.measurements/0","doc":"A map of measurements.\n\nSee\n[here](https://github.com/getsentry/sentry/blob/a8c960a933d2ded5225841573d8fc426a482ca9c/static/app/utils/discover/fields.tsx#L654-L676)\nfor the list of supported keys (which could change in the future).","ref":"Sentry.Transaction.html#t:measurements/0"},{"type":"type","title":"Sentry.Transaction.t/0","doc":"","ref":"Sentry.Transaction.html#t:t/0"},{"type":"type","title":"Sentry.Transaction.transaction_info/0","doc":"Transaction information.\n\nShould only be set by integrations and not developers directly.","ref":"Sentry.Transaction.html#t:transaction_info/0"},{"type":"module","title":"Sentry.LiveViewHook","doc":"A module that provides a `Phoenix.LiveView` hook to add Sentry context and breadcrumbs.\n\n*Available since v10.5.0.*\n\nThis module sets context and breadcrumbs for the live view process through\n`Sentry.Context`. It sets things like:\n\n  * The request URL\n  * The user agent and user's IP address\n  * Breadcrumbs for events that happen within LiveView\n\nTo make this module work best, you'll need to fetch information from the LiveView's\nWebSocket. You can do that when calling the `socket/3` macro in your Phoenix endpoint.\nFor example:\n\n    socket \"/live\", Phoenix.LiveView.Socket,\n      websocket: [connect_info: [:peer_data, :uri, :user_agent]]","ref":"Sentry.LiveViewHook.html"},{"type":"module","title":"Examples - Sentry.LiveViewHook","doc":"defmodule MyApp.UserLive do\n      use Phoenix.LiveView\n\n      on_mount Sentry.LiveViewHook\n\n      # ...\n    end\n\nYou can do the same at the router level:\n\n    live_session :default, on_mount: Sentry.LiveViewHook do\n      scope \"...\" do\n        # ...\n      end\n    end\n\nYou can also set this in your `MyAppWeb` module, so that all LiveViews that\n`use MyAppWeb, :live_view` will have this hook.","ref":"Sentry.LiveViewHook.html#module-examples"},{"type":"module","title":"Sentry.PlugCapture","doc":"Ensures proper error reporting for Plug applications that use Cowboy.\n\nIt is intended for usage with `Sentry.PlugContext`, which adds relevant request\nmetadata to the Sentry context before errors are captured.\n\n> #### Only for Cowboy {: .info}\n>\n> `Sentry.PlugCapture` is only recommended for Cowboy applications.\n> For applications running on Bandit, which is the most recent default webserver\n> in Phoenix, `Sentry.PlugContext` should be enough, and using `Sentry.PlugCapture`\n> might result in duplicate errors.","ref":"Sentry.PlugCapture.html"},{"type":"module","title":"Usage - Sentry.PlugCapture","doc":"","ref":"Sentry.PlugCapture.html#module-usage"},{"type":"module","title":"With Phoenix - Sentry.PlugCapture","doc":"In a Phoenix application, it is important to use this module **before**\nthe Phoenix endpoint itself. It should be added to your `endpoint.ex` file:\n\n    defmodule MyApp.Endpoint\n      use Sentry.PlugCapture\n      use Phoenix.Endpoint, otp_app: :my_app\n\n      # ...\n    end","ref":"Sentry.PlugCapture.html#module-with-phoenix"},{"type":"module","title":"With Plug - Sentry.PlugCapture","doc":"In a Plug application, you can add this module *below* your router:\n\n    defmodule MyApp.PlugRouter do\n      use Plug.Router\n      use Sentry.PlugCapture\n\n      # ...\n    end\n\n> #### `use Sentry.PlugCapture` {: .info}\n>\n> When you `use Sentry.PlugCapture`, Sentry overrides your `c:Plug.call/2` callback\n> and adds capturing errors and reporting to Sentry. You can still re-override\n> that callback after `use Sentry.PlugCapture` if you need to.","ref":"Sentry.PlugCapture.html#module-with-plug"},{"type":"module","title":"Scrubbing Sensitive Data - Sentry.PlugCapture","doc":"> #### Since v9.1.0 {: .neutral}\n>\n> Scrubbing sensitive data in `Sentry.PlugCapture` is available since v9.1.0\n> of this library.\n\nLike `Sentry.PlugContext`, this module also supports scrubbing sensitive data\nout of errors. However, this module has to do some *guessing* to figure\nout if there are `Plug.Conn` structs to scrub. Right now, the strategy we\nuse follows these steps:\n\n  1. if the error is `Phoenix.ActionClauseError`, we scrub the `Plug.Conn` structs\n    from the `args` field of that exception\n\nOtherwise, we don't perform any scrubbing. To configure scrubbing, you can use the\n`:scrubbing` option (see below).","ref":"Sentry.PlugCapture.html#module-scrubbing-sensitive-data"},{"type":"module","title":"Options - Sentry.PlugCapture","doc":"* `:scrubber` (since v9.1.0) - a term of type `{module, function, args}` that\n    will be invoked to scrub sensitive data from `Plug.Conn` structs. The\n    `Plug.Conn` struct is prepended to `args` before invoking the function,\n    so that the final function will be called as `apply(module, function, [conn | args])`.\n    The function must return a `Plug.Conn` struct. By default, the built-in\n    scrubber does this:\n\n    * scrubs *all* cookies\n    * scrubs sensitive headers just like `Sentry.PlugContext.default_header_scrubber/1`\n    * scrubs sensitive body params just like `Sentry.PlugContext.default_body_scrubber/1`","ref":"Sentry.PlugCapture.html#module-options"},{"type":"module","title":"Sentry.PlugContext","doc":"A **Plug** for adding request context to Sentry events.\n\nThis module adds Sentry context metadata during the request in a Plug\napplication. It includes defaults for scrubbing sensitive data, and options for\ncustomizing such behavior.","ref":"Sentry.PlugContext.html"},{"type":"module","title":"Usage - Sentry.PlugContext","doc":"You can use this module in a Plug pipeline to add Sentry metadata:\n\n    plug Sentry.PlugContext\n\nThis plug will add context metadata to the request, which will be added to\nreported errors that happen during plug execution. For Cowboy\napplications, you will also need to use `Sentry.PlugCapture`.","ref":"Sentry.PlugContext.html#module-usage"},{"type":"module","title":"Scrubbing `POST` Body Params - Sentry.PlugContext","doc":"In order to send `POST` body parameters you should first scrub them of sensitive\ninformation. By default, they will be scrubbed with `default_body_scrubber/1`. This\ncan be overridden by passing the `:body_scrubber` option, which accepts a `Plug.Conn`\nand returns a map to send.  Setting `:body_scrubber` to `nil` will not send any data\nback. If you would like to make use of Sentry's default scrubber behavior in a custom\nscrubber, it can be called directly. An example configuration may look like\nthe following:\n\n    defmodule MySentryScrubber do\n      def scrub_params(conn) do\n        # Makes use of the default body_scrubber to avoid sending password\n        # and credit card information in plain text. To also prevent sending\n        # our sensitive \"my_secret_field\" and \"other_sensitive_data\" fields,\n        # we simply drop those keys.\n        conn\n        |> Sentry.PlugContext.default_body_scrubber()\n        |> Map.drop([\"my_secret_field\", \"other_sensitive_data\"])\n      end\n    end\n\nThen pass it into `Sentry.PlugContext`:\n\n    plug Sentry.PlugContext, body_scrubber: &MySentryScrubber.scrub_params/1\n\nYou can also pass it in as a `{module, fun}`, like so:\n\n    plug Sentry.PlugContext, body_scrubber: {MySentryScrubber, :scrub_params}\n\n> #### Large Files {: .tip}\n>\n> If you are sending large files in `POST` requests, we recommend you\n> scrub them out through the `:body_scrubber` mechanism.","ref":"Sentry.PlugContext.html#module-scrubbing-post-body-params"},{"type":"module","title":"Scrubbing Headers - Sentry.PlugContext","doc":"By default, Sentry uses `default_header_scrubber/1` to scrub headers. This can be\nconfigured similarly to body params, through the `:header_scrubber` configuration\noption:\n\n    defmodule MySentryScrubber do\n      def scrub_headers(conn) do\n        # In this example, we do not want to include Content-Type or User-Agent\n        # in reported headers, so we drop them.\n        conn.req_headers\n        |> Map.new()\n        |> Sentry.PlugContext.default_header_scrubber()\n        |> Map.drop([\"content-type\", \"user-agent\"])\n      end\n    end\n\nThen, pass it into `Sentry.PlugContext`:\n\n    plug Sentry.PlugContext, header_scrubber: &MySentryScrubber.scrub_headers/1\n\nIt can also be passed in as a `{module, fun}` like so:\n\n    plug Sentry.PlugContext, header_scrubber: {MySentryScrubber, :scrub_headers}","ref":"Sentry.PlugContext.html#module-scrubbing-headers"},{"type":"module","title":"Scrubbing Cookies - Sentry.PlugContext","doc":"By default Sentry will scrub all cookies before sending events\n(see `scrub_cookies/1`). It can be configured similarly to the headers\nand body scrubbers, but is configured via the `:cookie_scrubber` key.\n\nFor example:\n\n    plug Sentry.PlugContext, cookie_scrubber: &MySentryScrubber.scrub_cookies/1","ref":"Sentry.PlugContext.html#module-scrubbing-cookies"},{"type":"module","title":"Scrubbing URLs - Sentry.PlugContext","doc":"*Available since v10.2.0.*\n\nIf any of your URLs contain sensitive tokens or other data, you should scrub them\nto remove the sensitive data. This can be configured similarly to body params,\nthrough the `:url_scrubber` configuration option. It should return a string:\n\n    defmodule MySentryScrubber do\n      def scrub_url(conn) do\n        conn\n        |> Plug.Conn.request_url()\n        |> String.replace(~r/secret-token/w+/, \"secret-token/****\")\n      end\n    end\n\nThen pass it into `Sentry.PlugContext`:\n\n    plug Sentry.PlugContext, url_scrubber: &MySentryScrubber.scrub_url/1\n\nYou can also pass it in as a `{module, fun}`, like so:\n\n    plug Sentry.PlugContext, url_scrubber: {MySentryScrubber, :scrub_url}","ref":"Sentry.PlugContext.html#module-scrubbing-urls"},{"type":"module","title":"Including Request Identifiers - Sentry.PlugContext","doc":"If you're using Phoenix, `Plug.RequestId`, or any other method to set a *request ID*\nresponse header, and would like to include that information with errors\nreported by `Sentry.PlugContext`, use the `:request_id_header` option. It allows you to set\nwhich header key Sentry should check. It defaults to `x-request-id`,\nwhich `Plug.RequestId` (and therefore Phoenix) also default to.\n\n    plug Sentry.PlugContext, request_id_header: \"application-request-id\"","ref":"Sentry.PlugContext.html#module-including-request-identifiers"},{"type":"module","title":"Remote Address Reader - Sentry.PlugContext","doc":"`Sentry.PlugContext` includes a request's originating IP address under the `REMOTE_ADDR`\nenvironment key in Sentry. By default, we read it from the `x-forwarded-for` HTTP header,\nand if this header is not present, from `conn.remote_ip`.\n\nIf you wish to read this value differently (for example, from a different HTTP header),\nor modify it in some other way (such as by masking it), you can configure this behavior\nby passing the `:remote_address_reader` option:\n\n    plug Sentry.PlugContext, remote_address_reader: &MyModule.read_ip/1\n\nThe `:remote_address_reader` option must be a function that accepts a `Plug.Conn`\nreturns a `t:String.t/0` IP, or a `{module, function}` tuple, where `module.function/1`\ntakes a `Plug.Conn` and returns a `t:String.t/0` IP.","ref":"Sentry.PlugContext.html#module-remote-address-reader"},{"type":"function","title":"Sentry.PlugContext.default_body_scrubber/1","doc":"Scrubs the body of a request.\n\nThe default scrubbed keys are:\n\n*  `password`\n*  `passwd`\n*  `secret`","ref":"Sentry.PlugContext.html#default_body_scrubber/1"},{"type":"function","title":"Sentry.PlugContext.default_cookie_scrubber/1","doc":"Scrubs **all** cookies off of the request.","ref":"Sentry.PlugContext.html#default_cookie_scrubber/1"},{"type":"function","title":"Sentry.PlugContext.default_header_scrubber/1","doc":"Scrubs the headers of a request.\n\nThe default scrubbed headers are:\n\n*  `authorization`\n*  `authentication`\n*  `cookie`","ref":"Sentry.PlugContext.html#default_header_scrubber/1"},{"type":"function","title":"Sentry.PlugContext.default_url_scrubber/1","doc":"Returns the request URL without modifying it.","ref":"Sentry.PlugContext.html#default_url_scrubber/1"},{"type":"module","title":"Sentry.LoggerBackend","doc":"An Elixir `Logger` backend that reports logged messages and crashes to Sentry.\n\n> #### `:logger` handler {: .warn}\n>\n> This module will eventually become **legacy**. Elixir `Logger` backends will\n> eventually be deprecated in favor of Erlang [`:logger`\n> handlers](https://www.erlang.org/doc/apps/kernel/logger_chapter.html#handlers).\n>\n> Sentry already has a `:logger` handler, `Sentry.LoggerHandler`. In new projects\n> and wherever possible, use `Sentry.LoggerHandler` in favor of this backend.\n\nTo include in your application, start this backend in your application `start/2` callback:\n\n    # lib/my_app/application.ex\n    def start(_type, _args) do\n      Logger.add_backend(Sentry.LoggerBackend)\n\nSentry context will be included in metadata in reported events. Example:\n\n    Sentry.Context.set_user_context(%{\n      user_id: current_user.id\n    })\n\n> #### `:logger` handler {: .tip}\n>\n> In new projects, try to use `Sentry.LoggerHandler` rather than this `Logger`\n> backend. Elixir will likely deprecate `Logger` backends in the future in\n> favor of `:logger` handlers, which would lead to us eventually removing this\n> backend.","ref":"Sentry.LoggerBackend.html"},{"type":"module","title":"Configuration - Sentry.LoggerBackend","doc":"* `:excluded_domains` - Any messages with a domain in the configured\nlist will not be sent. Defaults to `[:cowboy]` to avoid double reporting\nevents from `Sentry.PlugCapture`.\n\n* `:metadata` - To include non-Sentry Logger metadata in reports, the\n`:metadata` key can be set to a list of keys. Metadata under those keys will\nbe added in the `:extra` context under the `:logger_metadata` key. Defaults\nto `[]`. If set to `:all`, all metadata will be included. `:all` is available\nsince v9.0.0 of this library.\n\n* `:level` - The minimum [Logger level](https://hexdocs.pm/logger/Logger.html#module-levels)\n  to send events for. Defaults to `:error`.\n\n* `:capture_log_messages` - When `true`, this module will send all Logger\nmessages. Defaults to `false`, which will only send messages with metadata\nthat has the shape of an exception and stacktrace.\n\nExample:\n\n    config :logger, Sentry.LoggerBackend,\n      # Also send warning messages\n      level: :warning,\n      # Send messages from Plug/Cowboy\n      excluded_domains: [],\n      # Include metadata added with `Logger.metadata([foo_bar: \"value\"])`\n      metadata: [:foo_bar],\n      # Send messages like `Logger.error(\"error\")` to Sentry\n      capture_log_messages: true","ref":"Sentry.LoggerBackend.html#module-configuration"},{"type":"module","title":"Sentry.LoggerHandler","doc":"A highly-configurable [`:logger` handler](https://www.erlang.org/doc/apps/kernel/logger_chapter.html#handlers)\nthat reports logged messages and crashes to Sentry.\n\n*This module is available since v9.0.0 of this library*.\n\n> #### When to Use the Handler vs the Backend? {: .info}\n>\n> Sentry's Elixir SDK also ships with `Sentry.LoggerBackend`, an Elixir `Logger`\n> backend. The backend has similar functionality to this handler. The main functional\n> difference is that `Sentry.LoggerBackend` runs in its own process, while\n> `Sentry.LoggerHandler` runs in the process that logs. The latter is generally\n> preferable.\n>\n> The reason both exist is that `:logger` handlers are a relatively-new\n> feature in Erlang/OTP, and `Sentry.LoggerBackend` was created before `:logger`\n> handlers were introduced.\n>\n> In general, use `Sentry.LoggerHandler` whenever possible. In future Elixir releases,\n> `Logger` backends may become deprecated and hence `Sentry.LoggerBackend` may be\n> eventually removed.","ref":"Sentry.LoggerHandler.html"},{"type":"module","title":"Features - Sentry.LoggerHandler","doc":"This logger handler provides the features listed here.","ref":"Sentry.LoggerHandler.html#module-features"},{"type":"module","title":"Crash Reports - Sentry.LoggerHandler","doc":"The reason you'll want to add this handler to your application is so that you can\nreport **crashes** in your system to Sentry. Sometimes, you're able to catch exceptions\nand handle them (such as reporting them to Sentry), which is what you can do with\n`Sentry.PlugCapture` for example.\n\nHowever, Erlang/OTP systems are made of processes running concurrently, and\nsometimes those processes **crash and exit**. If you're not explicitly catching\nexceptions in those processes to report them to Sentry, then you won't see those\ncrash reports in Sentry. That's where this handler comes in. This handler hooks\ninto `:logger` and reports nicely-formatted crash reports to Sentry.","ref":"Sentry.LoggerHandler.html#module-crash-reports"},{"type":"module","title":"Overload Protection - Sentry.LoggerHandler","doc":"This handler has built-in *overload protection* via the `:sync_threshold`\nconfiguration option. Under normal circumstances, this handler sends events to\nSentry asynchronously, without blocking the logging process. However, if the\nnumber of queued up events exceeds the `:sync_threshold`, then this handler\nstarts *blocking* the logging process until the event is sent.\n\n*Overload protection is available since v10.6.0*.","ref":"Sentry.LoggerHandler.html#module-overload-protection"},{"type":"module","title":"Rate Limiting - Sentry.LoggerHandler","doc":"You can configure this handler to rate-limit the number of messages it sends to\nSentry. This can help avoid \"spamming\" Sentry. See the `:rate_limiting` configuration\noption.\n\n*Rate limiting is available since v10.5.0*.","ref":"Sentry.LoggerHandler.html#module-rate-limiting"},{"type":"module","title":"Usage - Sentry.LoggerHandler","doc":"To add this handler to your system, see [the documentation for handlers in\nElixir](https://hexdocs.pm/logger/Logger.html#module-erlang-otp-handlers).\n\nYou can configure this handler in the `:logger` key under your application's configuration,\npotentially alongside other `:logger` handlers:\n\n    config :my_app, :logger, [\n      {:handler, :my_sentry_handler, Sentry.LoggerHandler, %{\n        config: %{metadata: [:file, :line]}\n      }}\n    ]\n\nIf you do this, then you'll want to add this to your application's `c:Application.start/2`\ncallback, similarly to what you would do with `Sentry.LoggerBackend` and the\ncall to `Logger.add_backend/1`:\n\n    def start(_type, _args) do\n      Logger.add_handlers(:my_app)\n\n      # ...\n    end\n\nAlternatively, you can *skip the `:logger` configuration* and add the handler directly\nto your application's `c:Application.start/2` callback:\n\n    def start(_type, _args) do\n      :logger.add_handler(:my_sentry_handler, Sentry.LoggerHandler, %{\n        config: %{metadata: [:file, :line]}\n      })\n\n      # ...\n    end","ref":"Sentry.LoggerHandler.html#module-usage"},{"type":"module","title":"Configuration - Sentry.LoggerHandler","doc":"This handler supports the following configuration options:\n\n* `:level` (`t:Logger.level/0`) - The minimum [`Logger`\n  level](https://hexdocs.pm/logger/Logger.html#module-levels) to send events for. The default value is `:error`.\n\n* `:excluded_domains` (list of `t:atom/0`) - Any messages with a domain in the configured list will not be sent. The default is so as\n  to avoid double-reporting events from `Sentry.PlugCapture`. The default value is `[:cowboy]`.\n\n* `:metadata` (list of `t:atom/0`, or `:all`) - Use this to include non-Sentry logger metadata in reports. If it's a list of keys, metadata\n  in those keys will be added in the `:extra` context (see\n  `Sentry.Context.set_extra_context/1`) under the `:logger_metadata` key.\n  If set to `:all`, all metadata will be included. The default value is `[]`.\n\n* `:tags_from_metadata` (list of `t:atom/0`) - Use this to include logger metadata as tags in reports. Metadata under the specified keys\n  in those keys will be added as tags to the event. *Available since v10.9.0*. The default value is `[]`.\n\n* `:capture_log_messages` (`t:boolean/0`) - When `true`, this module will report all logged messages to Sentry (provided they're not\n  filtered by `:excluded_domains` and `:level`). The default of `false` means that the\n  handler will only send **crash reports**, which are messages with metadata that has the\n  shape of an exit reason and a stacktrace. The default value is `false`.\n\n* `:rate_limiting` (`t:keyword/0` or `nil`) - *since v10.4.0* - If present, enables rate\n  limiting of reported messages. This can help avoid \"spamming\" Sentry with\n  repeated log messages. To disable rate limiting, set this to `nil` or don't\n  pass it altogether.\n\n  * `:max_events` (`t:non_neg_integer/0`) - Required. The maximum number of events to send to Sentry in the `:interval` period.\n\n  * `:interval` (`t:non_neg_integer/0`) - Required. The interval (in *milliseconds*) to send `:max_events` events.\n\n  The default value is `nil`.\n\n* `:sync_threshold` - (*since v10.6.0*) The number of queued events after which this handler switches\n  to *sync mode*. Generally, this handler sends messages to Sentry **asynchronously**,\n  equivalent to using `result: :none` in `Sentry.send_event/2`. However, if the number\n  of queued events exceeds this threshold, the handler will switch to *sync mode*,\n  where it starts using `result: :sync` to block until the event is sent. If you always\n  want to use sync mode, set this option to `0`. This option effectively implements\n  **overload protection**.\n\n  If you would rather *drop events* to shed load instead, use the `:discard_threshold` option.\n  `:sync_threshold` and `:discard_threshold` cannot be used together. The default behavior\n  of the handler is to switch to sync mode, so to disable this option and discard events\n  instead set `:sync_threshold` to `nil` and set `:discard_threshold` instead.\n\n  The default value is `100`.\n\n* `:discard_threshold` - (*since v10.9.0*) The number of queued events after which this handler will start\n  to **discard** events. This option effectively implements **load shedding**.\n\n  `:discard_threshold` and `:sync_threshold` cannot be used together. If you set this option,\n  set `:sync_threshold` to `nil`.\n\n  The default value is `nil`.","ref":"Sentry.LoggerHandler.html#module-configuration"},{"type":"module","title":"Examples - Sentry.LoggerHandler","doc":"To log all messages with level `:error` and above to Sentry, set `:capture_log_messages`\nto `true`:\n\n    config :my_app, :logger, [\n      {:handler, :my_sentry_handler, Sentry.LoggerHandler, %{\n        config: %{metadata: [:file, :line], capture_log_messages: true, level: :error}\n      }}\n    ]\n\nNow, logs like this will be reported as messages to Sentry:\n\n    Logger.error(\"Something went wrong\")\n\nIf you want to customize options for the reported message, use the `:sentry` metadata\nkey in the `Logger` call. For example, to add a tag to the Sentry event:\n\n    Logger.error(\"Something went wrong\", sentry: [tags: %{my_tag: \"my_value\"}])\n\nSentry context (in `:sentry`) is also read from the logger metadata, so you can configure\nit for a whole process (with `Logger.metadata/1`). Last but not least, context is also read\nfrom the ancestor chain of the process (`:\"$callers\"`), so if you set `:sentry` context\nin a process and then spawn something like a task or a GenServer from that process,\nthe context will be included in the reported messages.","ref":"Sentry.LoggerHandler.html#module-examples"},{"type":"module","title":"Sentry.Attachment","doc":"A struct to represent an **attachment**.\n\nYou can send attachments over to Sentry alongside an event. See:\n .\n\nTo add attachments, use `Sentry.Context.add_attachment/1`.\n\n*Available since v10.1.0*.","ref":"Sentry.Attachment.html"},{"type":"type","title":"Sentry.Attachment.t/0","doc":"The type for the attachment struct.","ref":"Sentry.Attachment.html#t:t/0"},{"type":"module","title":"Sentry.CheckIn","doc":"This module represents the struct for a \"check-in\".\n\nCheck-ins are used to report the status of a monitor to Sentry. This is used\nto track the health and progress of **cron jobs**. This module is somewhat\nlow level, and mostly useful when you want to report the status of a cron\nbut you are not using any common library to manage your cron jobs.\n\n> #### Using `capture_check_in/1` {: .tip}\n>\n> Instead of using this module directly, you'll probably want to use\n> `Sentry.capture_check_in/1` to manually report the status of your cron jobs.\n\nSee  . This struct is available\nsince v10.2.0.","ref":"Sentry.CheckIn.html"},{"type":"function","title":"Sentry.CheckIn.new/1","doc":"Creates a new check-in struct with the given options.","ref":"Sentry.CheckIn.html#new/1"},{"type":"function","title":"Options - Sentry.CheckIn.new/1","doc":"The options you can pass match a subset of the fields of the `t:t/0` struct.\nYou can pass:\n\n* `:check_in_id` (`t:String.t/0`)\n\n* `:status` (`t:status/0`) - Required.\n\n* `:monitor_slug` (`t:String.t/0`) - Required.\n\n* `:duration` (`t:number/0`)\n\n* `:contexts` (`t:map/0`) - The contexts to attach to the check-in. This is a map of arbitrary data,\n  but right now Sentry supports the `trace_id` key under the\n  [trace context](https://develop.sentry.dev/sdk/event-payloads/contexts/#trace-context)\n  to connect the check-in with related errors. The default value is `%{}`.\n\n* `:monitor_config` (`t:keyword/0`) - If you pass this optional option, you **must** pass the nested `:schedule` option. The\n  options below are described in detail in the [Sentry\n  documentation](https://develop.sentry.dev/sdk/telemetry/check-ins/#monitor-upsert-support).\n\n  * `:checkin_margin` (`t:number/0`)\n\n  * `:max_runtime` (`t:number/0`)\n\n  * `:failure_issue_threshold` (`t:number/0`)\n\n  * `:recovery_threshold` (`t:number/0`)\n\n  * `:timezone` (`t:String.t/0`)\n\n  * `:owner` (`t:String.t/0`)\n\n  * `:schedule` (`t:monitor_config_schedule/0`)","ref":"Sentry.CheckIn.html#new/1-options"},{"type":"function","title":"Examples - Sentry.CheckIn.new/1","doc":"iex> check_in = CheckIn.new(status: :ok, monitor_slug: \"my-slug\")\n    iex> check_in.status\n    :ok\n    iex> check_in.monitor_slug\n    \"my-slug\"","ref":"Sentry.CheckIn.html#new/1-examples"},{"type":"type","title":"Sentry.CheckIn.monitor_config/0","doc":"The type for the monitor_config that can be part of the checking","ref":"Sentry.CheckIn.html#t:monitor_config/0"},{"type":"type","title":"Sentry.CheckIn.monitor_config_schedule/0","doc":"The possible values for the `:schedule` option under `:monitor_config`.\n\nIf the `:type` is `:crontab`, then the `:value` must be a string representing\na crontab expression. If the `:type` is `:interval`, then the `:value` must be\na number representing the interval and the `:unit` must be present and be one of `:year`,\n`:month`, `:week`, `:day`, `:hour`, or `:minute`.","ref":"Sentry.CheckIn.html#t:monitor_config_schedule/0"},{"type":"type","title":"Sentry.CheckIn.status/0","doc":"The possible status of the check-in.","ref":"Sentry.CheckIn.html#t:status/0"},{"type":"type","title":"Sentry.CheckIn.t/0","doc":"The type for the check-in struct.\n\n`:owner` within `:monitor_config` is available since v10.10.0.","ref":"Sentry.CheckIn.html#t:t/0"},{"type":"module","title":"Sentry.ClientReport","doc":"This module represents the data structure for a **client report**.\n\nClient reports are used to provide insights into which events are being\ndropped (that is, not sent to Sentry) and for what reason.\n\nThis module is responsible for recording, storing, and periodically sending these client\nreports to Sentry. You can choose to turn off these reports by configuring the\n`:send_client_reports` option.\n\nRefer to   for more details.\n\n*Available since v10.8.0*.","ref":"Sentry.ClientReport.html"},{"type":"type","title":"Sentry.ClientReport.reason/0","doc":"The possible reasons of the discarded event.","ref":"Sentry.ClientReport.html#t:reason/0"},{"type":"type","title":"Sentry.ClientReport.t/0","doc":"The struct for a **client report**.","ref":"Sentry.ClientReport.html#t:t/0"},{"type":"behaviour","title":"Sentry.HTTPClient","doc":"A behaviour for HTTP clients that Sentry can use.\n\nThe default HTTP client is `Sentry.HackneyClient`.\n\nTo configure a different HTTP client, implement the `Sentry.HTTPClient` behaviour and\nchange the `:client` configuration:\n\n    config :sentry,\n      client: MyHTTPClient","ref":"Sentry.HTTPClient.html"},{"type":"behaviour","title":"Child Spec - Sentry.HTTPClient","doc":"The `c:child_spec/0` callback is a callback that should be used when you want Sentry\nto start the HTTP client *under its supervision tree*. If you want to start your own\nHTTP client under your application's supervision tree, just don't implement the callback\nand Sentry won't do anything to start the client.\n\n> #### Optional Since v9.0.0 {: .warning}\n>\n> The `c:child_spec/0` callback is optional only since v9.0.0 of Sentry, and was required\n> before.","ref":"Sentry.HTTPClient.html#module-child-spec"},{"type":"behaviour","title":"Alternative Clients - Sentry.HTTPClient","doc":"Let's look at an example of using an alternative HTTP client. In this example, we'll\nuse [Finch](https://github.com/sneako/finch), a lightweight HTTP client for Elixir.\n\nFirst, we need to add Finch to our dependencies:\n\n    # In mix.exs\n    defp deps do\n      [\n        # ...\n        {:finch, \"~> 0.16\"}\n      ]\n    end\n\nThen, we need to define a module that implements the `Sentry.HTTPClient` behaviour:\n\n    defmodule MyApp.SentryFinchHTTPClient do\n      @behaviour Sentry.HTTPClient\n\n      @impl true\n      def child_spec do\n        Supervisor.child_spec({Finch, name: __MODULE__}, id: __MODULE__)\n      end\n\n      @impl true\n      def post(url, headers, body) do\n        request = Finch.build(:post, url, headers, body)\n\n        case Finch.request(request, __MODULE__) do\n          {:ok, %Finch.Response{status: status, headers: headers, body: body}} ->\n            {:ok, status, headers, body}\n\n          {:error, error} ->\n            {:error, error}\n        end\n      end\n    end\n\nLast, we need to configure Sentry to use our new HTTP client:\n\n    config :sentry,\n      client: MyApp.SentryFinchHTTPClient","ref":"Sentry.HTTPClient.html#module-alternative-clients"},{"type":"behaviour","title":"Umbrella Apps - Sentry.HTTPClient","doc":"The HTTP client for Sentry is configured globally for the `:sentry` application. In an\numbrella setup, this means that all applications must configure Sentry to use the same\nHTTP client.\n\nIf you want to use an alternative Sentry HTTP client in your umbrella application, we\nrecommend to do this:\n\n  1. Create a new application in the umbrella (we'll call it `sentry_http_client`).\n\n  1. Add `:sentry` as a dependency of the new application.\n\n  1. Add a new module to the new application (such as `SentryHTTPClient`) which implements\n     the desired `Sentry.HTTPClient` behaviour.\n\n  1. Configure `:sentry` to use the \"shared\" HTTP client. This works because configuration\n     in umbrella apps is generally shared by all apps within the umbrella (and it's in\n     `config/config.exs` at the root of the umbrella).\n\n         config :sentry,\n           # ...\n           client: SentryHTTPClient","ref":"Sentry.HTTPClient.html#module-umbrella-apps"},{"type":"callback","title":"Sentry.HTTPClient.child_spec/0","doc":"Should return a **child specification** to start the HTTP client.\n\nFor example, this can start a pool of HTTP connections dedicated to Sentry.\nIf not provided, Sentry won't do anything to start your HTTP client. See\n[the module documentation](#module-child-spec) for more info.","ref":"Sentry.HTTPClient.html#c:child_spec/0"},{"type":"callback","title":"Sentry.HTTPClient.post/3","doc":"Should make an HTTP `POST` request to `url` with the given `headers` and `body`.","ref":"Sentry.HTTPClient.html#c:post/3"},{"type":"type","title":"Sentry.HTTPClient.body/0","doc":"HTTP request or response body.","ref":"Sentry.HTTPClient.html#t:body/0"},{"type":"type","title":"Sentry.HTTPClient.headers/0","doc":"HTTP request or response headers.","ref":"Sentry.HTTPClient.html#t:headers/0"},{"type":"type","title":"Sentry.HTTPClient.status/0","doc":"The response status for an HTTP request.","ref":"Sentry.HTTPClient.html#t:status/0"},{"type":"module","title":"Sentry.HackneyClient","doc":"The built-in HTTP client.\n\nThis client implements the `Sentry.HTTPClient` behaviour.\n\nIt's based on the [hackney](https://github.com/benoitc/hackney) Erlang HTTP client,\nwhich is an *optional dependency* of this library. If you wish to use another\nHTTP client, you'll have to implement your own `Sentry.HTTPClient`. See the\ndocumentation for `Sentry.HTTPClient` for more information.\n\nSentry starts its own hackney pool called `:sentry_pool`. If you need to set other\n[hackney configuration options](https://github.com/benoitc/hackney/blob/master/doc/hackney.md#request5)\nfor things such as proxies, using your own pool, or response timeouts, the `:hackney_opts`\nconfiguration is passed directly to hackney for each request. See the configuration\ndocumentation in the `Sentry` module.","ref":"Sentry.HackneyClient.html"},{"type":"module","title":"Sentry.Interfaces","doc":"Top-level module for Sentry interfaces.\n\nInterfaces are pieces of the event payload that include various kinds of information.\nSee the [event payloads documentation](https://develop.sentry.dev/sdk/event-payloads/)\nand its subsections.\n\nThe types in this module and the nested structs are taken from Sentry's\n[JSONSchema definitions](https://github.com/getsentry/sentry-data-schemas/blob/ebc77d3cb2f3ef288913cce80a292ca0389a08e7/relay/event.schema.json).","ref":"Sentry.Interfaces.html"},{"type":"type","title":"Sentry.Interfaces.context/0","doc":"The generic **context** interface.\n\nSee  .","ref":"Sentry.Interfaces.html#t:context/0"},{"type":"type","title":"Sentry.Interfaces.user/0","doc":"The **user** interface.\n\nThis interface is not a *struct* since it allows any additional arbitrary key\nother than the ones defined in the schema.\n\nSee  .","ref":"Sentry.Interfaces.html#t:user/0"},{"type":"module","title":"Sentry.Interfaces.Breadcrumb","doc":"The struct for a single **breadcrumb** interface.\n\nSee  .","ref":"Sentry.Interfaces.Breadcrumb.html"},{"type":"type","title":"Sentry.Interfaces.Breadcrumb.t/0","doc":"","ref":"Sentry.Interfaces.Breadcrumb.html#t:t/0"},{"type":"module","title":"Sentry.Interfaces.Exception","doc":"The struct for the **exception** interface.\n\nSee  .","ref":"Sentry.Interfaces.Exception.html"},{"type":"type","title":"Sentry.Interfaces.Exception.t/0","doc":"","ref":"Sentry.Interfaces.Exception.html#t:t/0"},{"type":"module","title":"Sentry.Interfaces.Exception.Mechanism","doc":"The struct for the **exception mechanism** to be used within exceptions.\n\nSee `Sentry.Interfaces.Exception`.","ref":"Sentry.Interfaces.Exception.Mechanism.html"},{"type":"type","title":"Sentry.Interfaces.Exception.Mechanism.t/0","doc":"","ref":"Sentry.Interfaces.Exception.Mechanism.html#t:t/0"},{"type":"module","title":"Sentry.Interfaces.Message","doc":"The struct for the **message** interface.\n\nSee  .","ref":"Sentry.Interfaces.Message.html"},{"type":"type","title":"Sentry.Interfaces.Message.t/0","doc":"","ref":"Sentry.Interfaces.Message.html#t:t/0"},{"type":"module","title":"Sentry.Interfaces.Request","doc":"The struct for the **request** interface.\n\nSee  .","ref":"Sentry.Interfaces.Request.html"},{"type":"type","title":"Sentry.Interfaces.Request.t/0","doc":"","ref":"Sentry.Interfaces.Request.html#t:t/0"},{"type":"module","title":"Sentry.Interfaces.SDK","doc":"The struct for the **SDK** interface.\n\nThis is usually filled in by the SDK itself.\n\nSee  .","ref":"Sentry.Interfaces.SDK.html"},{"type":"type","title":"Sentry.Interfaces.SDK.t/0","doc":"","ref":"Sentry.Interfaces.SDK.html#t:t/0"},{"type":"module","title":"Sentry.Interfaces.Span","doc":"The struct for the **span** interface.\n\nSee  .","ref":"Sentry.Interfaces.Span.html"},{"type":"type","title":"Sentry.Interfaces.Span.t/0","doc":"","ref":"Sentry.Interfaces.Span.html#t:t/0"},{"type":"module","title":"Sentry.Interfaces.Stacktrace","doc":"The struct for the **stacktrace** interface.\n\nSee  .","ref":"Sentry.Interfaces.Stacktrace.html"},{"type":"type","title":"Sentry.Interfaces.Stacktrace.t/0","doc":"","ref":"Sentry.Interfaces.Stacktrace.html#t:t/0"},{"type":"module","title":"Sentry.Interfaces.Stacktrace.Frame","doc":"The struct for the **stacktrace frame** to be used within exceptions.\n\nSee `Sentry.Interfaces.Stacktrace`.","ref":"Sentry.Interfaces.Stacktrace.Frame.html"},{"type":"type","title":"Sentry.Interfaces.Stacktrace.Frame.t/0","doc":"","ref":"Sentry.Interfaces.Stacktrace.Frame.html#t:t/0"},{"type":"module","title":"Sentry.Interfaces.Thread","doc":"The struct for the **thread** interface.\n\nSee  .","ref":"Sentry.Interfaces.Thread.html"},{"type":"type","title":"Sentry.Interfaces.Thread.t/0","doc":"","ref":"Sentry.Interfaces.Thread.html#t:t/0"},{"type":"module","title":"Sentry.Test","doc":"Utilities for testing Sentry reports.","ref":"Sentry.Test.html"},{"type":"module","title":"Usage - Sentry.Test","doc":"This module is based on **collecting** reported events and then retrieving\nthem to perform assertions. The functionality here is only available if the\n`:test_mode` configuration option is set to `true`—see\n[`Sentry`'s configuration section](sentry.html#module-configuration).\nYou can start collecting events from a process\nby calling `start_collecting_sentry_reports/0`. Then, you can use Sentry\nas normal and report events (through functions such as `Sentry.capture_message/1`\nor `Sentry.capture_exception/1`). Finally, you can retrieve the collected events\nby calling `pop_sentry_reports/0`.\n\n> #### Test Mode and DSN {: .info}\n>\n> If `:test_mode` is `true`, the `:dsn` option behaves differently. When `:dsn` is\n> not set or `nil` and you're collecting events, you'll still be able to collect\n> events—even if under normal circumstances a missing `:dsn` means events don't get\n> reported. If `:dsn` is `nil` and you're not collecting events, the event is simply\n> ignored. See the table below for a summary for this behavior.\n\n| `:test_mode` | `:dsn` | Collecting events? | Behavior                                               |\n|--------------|--------|--------------------|--------------------------------------------------------|\n| `true`       | `nil`  | yes                | Event is collected                                     |\n| `true`       | `nil`  | no                 | Event is ignored (silently)                            |\n| `true`       | set    | yes                | Event is collected                                     |\n| `true`       | set    | no                 | Makes HTTP request to configured DSN (could be Bypass) |\n| `false`      | `nil`  | irrelevant         | Ignores event                                          |\n| `false`      | set    | irrelevant         | Makes HTTP request to configured DSN (could be Bypass) |","ref":"Sentry.Test.html#module-usage"},{"type":"module","title":"Examples - Sentry.Test","doc":"Let's imagine writing a test using the functions in this module. First, we need to\nstart collecting events:\n\n    test \"reporting from child processes\" do\n      parent_pid = self()\n\n      # Collect reports from self().\n      assert :ok = Test.start_collecting_sentry_reports()\n\n      #  \n    end\n\nNow, we can report events as normal. For example, we can report an event from the\nparent process:\n\n    assert {:ok, \"\"} = Sentry.capture_message(\"Oops from parent process\")\n\nWe can also report events from \"child\" processes.\n\n    # Spawn a child that waits for the :go message and then reports an event.\n    {:ok, child_pid} =\n      Task.start_link(fn ->\n        receive do\n          :go ->\n            assert {:ok, \"\"} = Sentry.capture_message(\"Oops from child process\")\n            send(parent_pid, :done)\n        end\n      end)\n\n    # Start the child and wait for it to finish.\n    send(child_pid, :go)\n    assert_receive :done\n\nNow, we can retrieve the collected events and perform assertions on them:\n\n    assert [%Event{} = event1, %Event{} = event2] = Test.pop_sentry_reports()\n    assert event1.message.formatted == \"Oops from parent process\"\n    assert event2.message.formatted == \"Oops from child process\"","ref":"Sentry.Test.html#module-examples"},{"type":"function","title":"Sentry.Test.allow_sentry_reports/2","doc":"Allows `pid_to_allow` to collect events back to the root process via `owner_pid`.\n\n`owner_pid` must be a PID that is currently collecting events or has been allowed\nto collect events. If that's not the case, this function raises an error.\n\n`pid_to_allow` can also be a **function** that returns a PID. This is useful when\nyou want to allow a registered process that is not yet started to collect events. For example:\n\n    Sentry.Test.allow_sentry_reports(self(), fn -> Process.whereis(:my_process) end)","ref":"Sentry.Test.html#allow_sentry_reports/2"},{"type":"function","title":"Sentry.Test.cleanup/1","doc":"Cleans up test resources associated with `owner_pid`.\n\nSee the `:cleanup` option in `start_collecting/1` and the corresponding\nexample for more information.","ref":"Sentry.Test.html#cleanup/1"},{"type":"function","title":"Sentry.Test.pop_sentry_reports/1","doc":"Pops all the collected events from the current process.\n\nThis function returns a list of all the events that have been collected from the current\nprocess and all the processes that were allowed through it. If the current process\nis not collecting events, this function raises an error.\n\nAfter this function returns, the current process will still be collecting events, but\nthe collected events will be reset to `[]`.","ref":"Sentry.Test.html#pop_sentry_reports/1"},{"type":"function","title":"Examples - Sentry.Test.pop_sentry_reports/1","doc":"iex> Sentry.Test.start_collecting_sentry_reports()\n    :ok\n    iex> Sentry.capture_message(\"Oops\")\n    {:ok, \"\"}\n    iex> [%Sentry.Event{} = event] = Sentry.Test.pop_sentry_reports()\n    iex> event.message.formatted\n    \"Oops\"","ref":"Sentry.Test.html#pop_sentry_reports/1-examples"},{"type":"function","title":"Sentry.Test.pop_sentry_transactions/1","doc":"Pops all the collected transactions from the current process.\n\nThis function returns a list of all the transactions that have been collected from the current\nprocess and all the processes that were allowed through it. If the current process\nis not collecting transactions, this function raises an error.\n\nAfter this function returns, the current process will still be collecting transactions, but\nthe collected transactions will be reset to `[]`.","ref":"Sentry.Test.html#pop_sentry_transactions/1"},{"type":"function","title":"Examples - Sentry.Test.pop_sentry_transactions/1","doc":"iex> Sentry.Test.start_collecting_sentry_reports()\n    :ok\n    iex> Sentry.send_transaction(Sentry.Transaction.new(%{span_id: \"123\", start_timestamp: \"2024-10-12T13:21:13\", timestamp: \"2024-10-12T13:21:13\", spans: []}))\n    {:ok, \"\"}\n    iex> [%Sentry.Transaction{}] = Sentry.Test.pop_sentry_transactions()","ref":"Sentry.Test.html#pop_sentry_transactions/1-examples"},{"type":"function","title":"Sentry.Test.start_collecting/1","doc":"Starts collecting events.\n\nThis function starts collecting events reported from the given (*owner*) process. If you want to\nallow other processes to report events, you need to *allow* them to report events back\nto the owner process. See `allow/2` for more information on allowances. If the owner\nprocess is already *allowed by another process*, this function raises an error.","ref":"Sentry.Test.html#start_collecting/1"},{"type":"function","title":"Options - Sentry.Test.start_collecting/1","doc":"* `:owner` - the PID of the owner process that will collect the events. Defaults to `self/0`.\n\n  * `:cleanup` - a boolean that controls whether collected resources around the owner process\n    should be cleaned up when the owner process exits. Defaults to `true`. If `false`, you'll\n    need to manually call `cleanup/1` to clean up the resources.","ref":"Sentry.Test.html#start_collecting/1-options"},{"type":"function","title":"Examples - Sentry.Test.start_collecting/1","doc":"The `:cleanup` option can be used to implement expectation-based tests, akin to something\nlike [`Mox.expect/4`](https://hexdocs.pm/mox/1.1.0/Mox.html#expect/4).\n\n    test \"implementing an expectation-based test workflow\" do\n      test_pid = self()\n\n      Test.start_collecting(owner: test_pid, cleanup: false)\n\n      on_exit(fn ->\n        assert [%Event{} = event] = Test.pop_sentry_reports(test_pid)\n        assert event.message.formatted == \"Oops\"\n        assert :ok = Test.cleanup(test_pid)\n      end)\n\n      assert {:ok, \"\"} = Sentry.capture_message(\"Oops\")\n    end","ref":"Sentry.Test.html#start_collecting/1-examples"},{"type":"function","title":"Sentry.Test.start_collecting_sentry_reports/1","doc":"Starts collecting events from the current process.\n\nThis function starts collecting events reported from the current process. If you want to\nallow other processes to report events, you need to *allow* them to report events back\nto the current process. See `allow/2` for more information on allowances. If the current\nprocess is already *allowed by another process*, this function raises an error.\n\nThe `context` parameter is ignored. It's there so that this function can be used\nas an ExUnit **setup callback**. For example:\n\n    import Sentry.Test\n\n    setup :start_collecting_sentry_reports\n\nFor a more flexible way to start collecting events, see `start_collecting/1`.","ref":"Sentry.Test.html#start_collecting_sentry_reports/1"},{"type":"exception","title":"Sentry.ClientError","doc":"An exception struct that represents an error returned by Sentry when\nreporting an error or a message.\n\nThis struct is designed to manage and handle errors originating from operations\nin the Sentry client. The `:reason` field contains the cause of the error\nas an atom or tuple (see `t:reason/0`).\n\nTo raise instances of this exception, you can use `raise/1`. When crafting\nformatted error messages for purposes such as logging or presentation, consider\nleveraging `Exception.message/1`.","ref":"Sentry.ClientError.html"},{"type":"function","title":"Sentry.ClientError.__struct__/0","doc":"The exception struct for a Sentry error.","ref":"Sentry.ClientError.html#__struct__/0"},{"type":"type","title":"Sentry.ClientError.reason/0","doc":"The reason for a Sentry error exception.","ref":"Sentry.ClientError.html#t:reason/0"},{"type":"type","title":"Sentry.ClientError.t/0","doc":"The type for a Sentry error exception.","ref":"Sentry.ClientError.html#t:t/0"},{"type":"extras","title":"README","doc":"_Bad software is everywhere, and we're tired of it. Sentry is on a mission to help developers write better software faster, so we can get back to enjoying technology. If you want to join us [ **Check out our open positions** ](https://sentry.io/careers/)_\n\n![Build Status](https://github.com/getsentry/sentry-elixir/actions/workflows/main.yml/badge.svg)\n[![Hex Package](https://img.shields.io/hexpm/v/sentry.svg)](https://hex.pm/packages/sentry)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-blue.svg)](https://hexdocs.pm/sentry)\n\nThis is the official Sentry SDK for [Sentry].\n\n*💁: This README documents unreleased features (from the `master` branch). For documentation on the current release, see [the official documentation][docs].*","ref":"readme.html"},{"type":"extras","title":"Getting Started - README","doc":"","ref":"readme.html#getting-started"},{"type":"extras","title":"Install - README","doc":"To use Sentry in your project, add it as a dependency in your `mix.exs` file.\n\nSentry does not install a JSON library nor an HTTP client by itself. Sentry will default to the [built-in `JSON`](https://hexdocs.pm/elixir/JSON.html) for JSON and [Hackney] for HTTP requests, but can be configured to use other ones. To use the default ones, do:\n\n```elixir\ndefp deps do\n  [\n    # ...\n\n    {:sentry, \"~> 10.8\"},\n    {:hackney, \"~> 1.20\"}\n  ]\nend\n```\n\n> [!WARNING]\n> If you're using an Elixir version before 1.18, the Sentry SDK will default to [Jason] as the JSON library. However, you **must** add it to your dependencies:\n>\n> ```elixir\n> defp deps do\n>   [\n>     # ...\n>     {:sentry, \"~> 10.8.1\"},\n>     {:jason, \"~> 1.4\"}\n>   ]\n> end\n> ```","ref":"readme.html#install"},{"type":"extras","title":"Configuration - README","doc":"Sentry has a range of configuration options, but most applications will have a configuration that looks like the following:\n\n```elixir\n# config/config.exs\nconfig :sentry,\n  dsn: \"https://public_key@app.getsentry.com/1\",\n  environment_name: config_env(),\n  enable_source_code_context: true,\n  root_source_code_paths: [File.cwd!()]\n```","ref":"readme.html#configuration"},{"type":"extras","title":"Usage - README","doc":"This library comes with a [`:logger` handler][logger-handlers] to capture error messages coming from process crashes. To enable this, add [`Sentry.LoggerHandler`](https://hexdocs.pm/sentry/Sentry.LoggerHandler.html) to your production configuration:\n\n```elixir\n# config/prod.exs\nconfig :my_app, :logger, [\n  {:handler, :my_sentry_handler, Sentry.LoggerHandler, %{\n    config: %{\n      metadata: [:file, :line],\n      rate_limiting: [max_events: 10, interval: _1_second = 1_000],\n      # Logs all messages with level `:error` and above to Sentry.\n      # Remove :capture_log_messages and :level if you only want to report crashes.\n      capture_log_messages: true,\n      level: :error\n    }\n  }}\n]\n\n```\n\nAnd then add your logger when your application starts:\n\n```elixir\n# lib/my_app/application.ex\ndef start(_type, _args) do\n  Logger.add_handlers(:my_app)\n\n  # ...\nend\n```\n\nAlternatively, you can skip the `:logger` configuration and add the handler directly\nto your application's `start/2` callback:\n\n```elixir\n# lib/my_app/application.ex\ndef start(_type, _args) do\n  :logger.add_handler(:my_sentry_handler, Sentry.LoggerHandler, %{\n    config: %{\n      metadata: [:file, :line],\n      rate_limiting: [max_events: 10, interval: _1_second = 1_000],\n      capture_log_messages: true,\n      level: :error\n    }\n  })\n\n  # ...\nend\n```\n\nSee all logger configuration options [here](https://hexdocs.pm/sentry/Sentry.LoggerHandler.html).\n\n#### Capture exceptions manually\n\nSometimes you want to capture specific exceptions manually. To do so, use [`Sentry.capture_exception/2`](https://hexdocs.pm/sentry/Sentry.html#capture_exception/2).\n\n```elixir\ntry do\n  ThisWillError.really()\nrescue\n  my_exception ->\n    Sentry.capture_exception(my_exception, stacktrace: __STACKTRACE__)\nend\n```\n\nSometimes you want to capture **messages** that are not exceptions. To do that, use [`Sentry.capture_message/2`](https://hexdocs.pm/sentry/Sentry.html#capture_exception/2):\n\n```elixir\nSentry.capture_message(\"custom_event_name\", extra: %{extra: information})\n```\n\nTo learn more about how to use this SDK, refer to [the documentation][docs].\n\n#### Testing Your Configuration\n\nTo ensure you've set up your configuration correctly we recommend running the\nincluded Mix task. It can be tested on different Mix environments and will tell you if it is not currently configured to send events in that environment:\n\n```bash\nMIX_ENV=dev mix sentry.send_test_event\n```","ref":"readme.html#usage"},{"type":"extras","title":"Testing with Sentry - README","doc":"In some cases, you may want to _test_ that certain actions in your application cause a report to be sent to Sentry. Sentry itself does this by using [Bypass]. It is important to note that when modifying the environment configuration the test case should not be run asynchronously, since you are modifying **global configuration**. Not returning the environment configuration to its original state could also affect other tests depending on how the Sentry configuration interacts with them. A good way to make sure to revert the environment is to use the [`on_exit/2`][exunit-on-exit] callback that ships with ExUnit.\n\nFor example:\n\n```elixir\ntest \"add/2 does not raise but sends an event to Sentry when given bad input\" do\n  bypass = Bypass.open()\n\n  Bypass.expect(bypass, fn conn ->\n    assert {:ok, _body, conn} = Plug.Conn.read_body(conn)\n    Plug.Conn.resp(conn, 200, ~s<{\"id\": \"340\"}>)\n  end)\n\n  Sentry.put_config(:dsn, \"http://public:secret@localhost:#{bypass.port}/1\")\n  Sentry.put_config(:send_result, :sync)\n\n  on_exit(fn ->\n    Sentry.put_config(:dsn, nil)\n    Sentry.put_config(:send_result, :none)\n  end)\n\n  MyModule.add(1, \"a\")\nend\n```\n\nWhen testing, you will also want to set the `:send_result` type to `:sync`, so that sending Sentry events blocks until the event is sent.","ref":"readme.html#testing-with-sentry"},{"type":"extras","title":"Integrations - README","doc":"* [Phoenix and Plug][setup-phoenix-and-plug]","ref":"readme.html#integrations"},{"type":"extras","title":"Contributing to the SDK - README","doc":"Please make sure to read the [CONTRIBUTING.md](CONTRIBUTING.md) before making a pull request.\n\nThanks to everyone who has contributed to this project so far.","ref":"readme.html#contributing-to-the-sdk"},{"type":"extras","title":"Getting Help/Support - README","doc":"If you need help setting up or configuring the Elixir SDK (or anything else in the Sentry universe) please head over to the [Sentry Community on Discord](https://discord.com/invite/Ww9hbqr). There is a ton of great people in our Discord community ready to help you!","ref":"readme.html#getting-help-support"},{"type":"extras","title":"Resources - README","doc":"* [![Documentation](https://img.shields.io/badge/documentation-hexdocs.svg)][docs]\n  * [![Forum](https://img.shields.io/badge/forum-sentry-green.svg)](https://forum.sentry.io/c/sdks)\n  * [![Discord](https://img.shields.io/discord/621778831602221064)](https://discord.gg/Ww9hbqr)\n  * [![Stack Overflow](https://img.shields.io/badge/stack%20overflow-sentry-green.svg)](http://stackoverflow.com/questions/tagged/sentry)\n  * [![Twitter Follow](https://img.shields.io/twitter/follow/getsentry?label=getsentry&style=social)](https://twitter.com/intent/follow?screen_name=getsentry)","ref":"readme.html#resources"},{"type":"extras","title":"License - README","doc":"Licensed under the MIT license, see [`LICENSE`](./LICENSE).\n\n[Sentry]: http://sentry.io/\n[Jason]: https://github.com/michalmuskala/jason\n[Hackney]: https://github.com/benoitc/hackney\n[Bypass]: https://github.com/PSPDFKit-labs/bypass\n[docs]: https://hexdocs.pm/sentry/readme.html\n[logger-handlers]: https://www.erlang.org/doc/apps/kernel/logger_chapter#handlers\n[setup-phoenix-and-plug]: https://hexdocs.pm/sentry/setup-with-plug-and-phoenix.html\n[exunit-on-exit]: https://hexdocs.pm/ex_unit/ExUnit.Callbacks.html#on_exit/2","ref":"readme.html#license"},{"type":"extras","title":"CHANGELOG","doc":"","ref":"changelog.html"},{"type":"extras","title":"11.0.1 - CHANGELOG","doc":"#### Various improvements\n\n- `Sentry.OpenTelemetry.Sampler` now works with an empty config ([#915](https://github.com/getsentry/sentry-elixir/pull/915))","ref":"changelog.html#11-0-1"},{"type":"extras","title":"11.0.0 - CHANGELOG","doc":"This release comes with a beta support for Traces using OpenTelemetry - please test it out and report any issues you find.","ref":"changelog.html#11-0-0"},{"type":"extras","title":"New features - CHANGELOG","doc":"- Beta support for Traces using OpenTelemetry ([#902](https://github.com/getsentry/sentry-elixir/pull/902))\n\n  To enable Tracing in your Phoenix application, you need to add the following to your `mix.exs`:\n\n  ```elixir\n  def deps do\n    [\n      # ...\n      {:sentry, \"~> 11.0.0\"},\n      {:opentelemetry, \"~> 1.5\"},\n      {:opentelemetry_api, \"~> 1.4\"},\n      {:opentelemetry_exporter, \"~> 1.0\"},\n      {:opentelemetry_semantic_conventions, \"~> 1.27\"},\n      {:opentelemetry_phoenix, \"~> 2.0\"},\n      {:opentelemetry_ecto, \"~> 1.2\"},\n      # ...\n    ]\n  ```\n\n  And then configure Tracing in Sentry and OpenTelemetry in your `config.exs`:\n\n  ```elixir\n  config :sentry,\n    # ...\n    traces_sample_rate: 1.0 # any value between 0 and 1.0 enables tracing\n\n  config :opentelemetry, span_processor: {Sentry.OpenTelemetry.SpanProcessor, []}\n  config :opentelemetry, sampler: {Sentry.OpenTelemetry.Sampler, []}\n  ```\n- Add installer (based on Igniter) ([#876](https://github.com/getsentry/sentry-elixir/pull/876))","ref":"changelog.html#new-features"},{"type":"extras","title":"Various improvements - CHANGELOG","doc":"- Tweak credit card regex handling for OTP-28 ([#898](https://github.com/getsentry/sentry-elixir/pull/898))\n\n# Changelog","ref":"changelog.html#various-improvements"},{"type":"extras","title":"10.10.0 - CHANGELOG","doc":"This release adds Telemetry crash reporting, fixes compatibility with Erlang/OTP 28, and includes several bug fixes.","ref":"changelog.html#10-10-0"},{"type":"extras","title":"New features - CHANGELOG","doc":"- Add Telemetry integration for capturing Telemetry crash events in Sentry (#887 by @whatyouhide)\n- Add `:owner` option for check-ins, providing more control over cron monitoring (#879 by @Miradorn)","ref":"changelog.html#new-features"},{"type":"extras","title":"Bug fixes - CHANGELOG","doc":"- Fix regexes on Erlang/OTP 28 (#889 by @josevalim)\n- Fix ignored exception in the default filter by correcting `Plug.Parsers.RequestTooLarge` reference (#884 by @mbaleczny)\n- Fix hyperlink tag in `Sentry.LoggerBackend` moduledoc (#880 by @bjacquet)\n- Remain compatible with new translation format to be introduced in Elixir 1.19 (#885 by @martosaur)","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Various improvements - CHANGELOG","doc":"- Update OTP and OS in CI (#882 by @solnic)","ref":"changelog.html#various-improvements"},{"type":"extras","title":"10.9.0 - CHANGELOG","doc":"This release adds a bunch of new features and fixes a few papercut bugs.","ref":"changelog.html#10-9-0"},{"type":"extras","title":"New features - CHANGELOG","doc":"- Add `:tags_from_metadata` option to `Sentry.LoggerHandler`. Use this to better structure reports that come from logs (#840 by @icehaunter).\n- Add `:discard_threshold` option to `Sentry.LoggerHandler` to implement load shedding when the logger gets overloaded.\n- If you want to use Elixir 1.18's new `JSON` module, now you can (#845).\n- Add `:in_app_otp_apps` configuration option. This should replace `:in_app_module_allow_list` for most use cases, making configuration simpler (#854 by @solnic).\n- Add support for per-module custom options for check ins. This means you can now configure single Oban (or Quantum) jobs with per-worker options such as timezones and more (#833 by @savhappy).\n- Add a global `:extra` config that can be set at the `:sentry` application level (akin to `:tags` today).\n- Improve Oban error reporting.","ref":"changelog.html#new-features"},{"type":"extras","title":"Bug fixes - CHANGELOG","doc":"- We now deduplicate identical events significantly less, reducing the risk of not reporting events that are not duplicates.\n- When dropping breadcrumbs (because of the limit being reached), we now retain *newest* breadcrumbs instead of older ones (#858 by @dajinchu).\n- Ensure log messages are not captured with `:capture_log_messages` is `false` (#865 by @joladev).\n- Normalize Oban exception reasons for better reports.","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"10.8.1 - CHANGELOG","doc":"","ref":"changelog.html#10-8-1"},{"type":"extras","title":"Various fixes & improvements - CHANGELOG","doc":"- Update to LiveView 1.0 🎉 (#826) by @solnic\n- Replace release bot with GH app (#828) by @Jeffreyhung","ref":"changelog.html#various-fixes-improvements"},{"type":"extras","title":"10.8.0 - CHANGELOG","doc":"This release bumps the minimum Elixir requirement to 1.13, fixes a few bugs, and introduces **client reports**. Client reports will be sent to Sentry by default, but you can disable them with:\n\n```elixir\nconfig :sentry,\n  # ...,\n  send_client_reports: false\n```","ref":"changelog.html#10-8-0"},{"type":"extras","title":"Improvements and new features - CHANGELOG","doc":"- Add support for [client reports](https://develop.sentry.dev/sdk/telemetry/client-reports/) (#801) by @savhappy\n- Add option for generating custom cron monitor slugs (#803) by @iautom8things\n- Improvements to documentation\n- Require Elixir 1.13+ (21f0f77e) by @whatyouhide\n- Validate that custom HTTP clients return correct stuff (#794) by @savhappy","ref":"changelog.html#improvements-and-new-features"},{"type":"extras","title":"Bug fixes - CHANGELOG","doc":"- Fix stacktraces with no frames (#787) by @savhappy\n- Special-case Ranch errors in the logger handler for OTP 25 (#818) by @whatyouhide\n- Few fixes to `mix sentry.send_test_event`\n- Handle Bandit exception when fetching peer data (#814) by @ardhitama\n- Support non-exception error values from Oban jobs (#807) by @savhappy","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"10.7.1 - CHANGELOG","doc":"","ref":"changelog.html#10-7-1"},{"type":"extras","title":"Various fixes & improvements - CHANGELOG","doc":"- Add `:monitor_config_defaults` integrations option (#782). — *@whatyouhide*\n- Allow `--no-compile`/`--no-check-deps` flags for `mix sentry.package_source_code` (#776). — *@razielgn*\n- Accept structs as structured logs in `Sentry.LoggerHandler` (#780). — *@mrdotb*\n- Fix a bug where we were accidentally sending the `:integration_meta` field (116140d6). — *@whatyouhide*\n- Reduce memory usage of source code maps (#777). — *@whatyouhide*","ref":"changelog.html#various-fixes-improvements"},{"type":"extras","title":"10.7.0 - CHANGELOG","doc":"","ref":"changelog.html#10-7-0"},{"type":"extras","title":"Various fixes & improvements - CHANGELOG","doc":"New features:\n\n- Add `Sentry.ClientError` for more structured client errors. You can use this to programmatically deal with errors when reporting events, if you need to. — *@savhappy*\n- Add `:integration_meta` key to `Sentry.Event`. — *(#771) by @savhappy*\n- Validate Sentry options even if DSN is not set. — *(#772) by @savhappy*\n\nBug fixes:\n\n- Fix Sentry check-ins by internally mapping check-in IDs for \"start\" and \"stop\" events. — *@savhappy*\n- Fix `mix sentry.package_source_code` edge cases by compiling code before running the task. — *@whatyouhide*\n- Support structured logs in `Sentry.LoggerHandler`. — *(#765) by @martosaur*\n- Handle `nil` environment correctly in Sentry config — *(#753) by @fahchen*\n- Fix exceptions with an empty stacktrace. — *(#755) by @savhappy*","ref":"changelog.html#various-fixes-improvements"},{"type":"extras","title":"10.6.2 - CHANGELOG","doc":"","ref":"changelog.html#10-6-2"},{"type":"extras","title":"Various fixes & improvements - CHANGELOG","doc":"- Fix on_mount LiveView hook when given :not_mounted_at_router (#742) by @savhappy\n- Strengthen some Logger tests (#743) by @whatyouhide\n- Show contributors on README (#741) by @stephanie-anderson\n- Add :bandit to list of ignored logger domains (#739) by @mtrudel","ref":"changelog.html#various-fixes-improvements"},{"type":"extras","title":"10.6.1 - CHANGELOG","doc":"","ref":"changelog.html#10-6-1"},{"type":"extras","title":"Various fixes & improvements - CHANGELOG","doc":"- Only fetch LiveView socket info if root (#734) by @whatyouhide","ref":"changelog.html#various-fixes-improvements"},{"type":"extras","title":"10.6.0 - CHANGELOG","doc":"","ref":"changelog.html#10-6-0"},{"type":"extras","title":"Various fixes & improvements - CHANGELOG","doc":"- Add overload protection to `:logger` handler (#727).\n- Expose DSN via new `Sentry.get_dsn/0` (#731).\n- Fix a bug with nameless Quantum cron jobs support in the Quantum integration.","ref":"changelog.html#various-fixes-improvements"},{"type":"extras","title":"10.5.0 - CHANGELOG","doc":"","ref":"changelog.html#10-5-0"},{"type":"extras","title":"Various fixes & improvements - CHANGELOG","doc":"- Improve resilience of looking at Retry-After (ab7fbb96) by @whatyouhide\n- Fix compilation error (cf93d226) by @whatyouhide\n- Honor Retry-After responses from Sentry (5bad4b56) by @whatyouhide\n- Improve \"GenServer terminating\" reports (#723) by @whatyouhide\n- Don't report empty stacktraces (bed583f5) by @whatyouhide\n- Add LiveView hook (#722) by @whatyouhide\n- FIx monitor slug in Oban + Quantum integrations (#721) by @whatyouhide","ref":"changelog.html#various-fixes-improvements"},{"type":"extras","title":"10.4.0 - CHANGELOG","doc":"","ref":"changelog.html#10-4-0"},{"type":"extras","title":"Various fixes & improvements - CHANGELOG","doc":"- Add rate-limiting to `Sentry.LoggerHandler`.\n- Improve reporting of process crashes in `Sentry.LoggerHandler`.\n- Fix loading configuration in `mix sentry.send_test_event`.\n- Fix JSON libraries that raise errors when encoding.\n- Allow `Sentry.LoggerBackend` and `Sentry.LoggerHandler` to use Sentry metadata.\n- Validate configuration passed to `Sentry.LoggerHandler`.","ref":"changelog.html#various-fixes-improvements"},{"type":"extras","title":"10.3.0 - CHANGELOG","doc":"","ref":"changelog.html#10-3-0"},{"type":"extras","title":"Various fixes & improvements - CHANGELOG","doc":"- Fix compilation warning (83a727a3) by @whatyouhide\n- Move some integrations-related modules around (8eeca145) by @whatyouhide\n- Add integrated support for capturing Oban errors (#705) by @whatyouhide","ref":"changelog.html#various-fixes-improvements"},{"type":"extras","title":"10.2.1 - CHANGELOG","doc":"","ref":"changelog.html#10-2-1"},{"type":"extras","title":"Various fixes & improvements - CHANGELOG","doc":"- Fix automatic start integrations (#704) by @vshev4enko\n- Fix wrong CLI argument in CI (#701) by @vshev4enko\n- Update changelog (d6da0fbe) by @whatyouhide","ref":"changelog.html#various-fixes-improvements"},{"type":"extras","title":"10.2.0 - CHANGELOG","doc":"","ref":"changelog.html#10-2-0"},{"type":"extras","title":"New features - CHANGELOG","doc":"- Add support for [Sentry Cron](https://docs.sentry.io/product/crons/) monitoring, with built-in support for [Oban](https://github.com/sorentwo/oban) and [Quantum](https://github.com/quantum-elixir/quantum-core).\n- Add `Sentry.capture_check_in/1`, which can be used to manually check-in crons.\n- Add `--output` flag for the `mix sentry.package_source_code` task. This can be useful for read-only build environments.\n- Introduce testing helpers in `Sentry.Test`.\n- Add the `:url_scrubber` option to `Sentry.PlugContext`.","ref":"changelog.html#new-features"},{"type":"extras","title":"Various fixes & improvements - CHANGELOG","doc":"- Improve error message on unavailable config.","ref":"changelog.html#various-fixes-improvements"},{"type":"extras","title":"10.1.0 - CHANGELOG","doc":"","ref":"changelog.html#10-1-0"},{"type":"extras","title":"Various fixes & improvements - CHANGELOG","doc":"- Add `Sentry.Interfaces.Thread` to fix stacktraces in messages.\n- Add the `--type` and `--no-stacktrace` flags to `mix sentry.send_test_message`.\n- Add support for interpolating messages (with `%s`) placeholders. See `Sentry.capture_message/2`.\n- Add support for attachments; see `Sentry.Attachment` and `Sentry.Context.add_attachment/1`.","ref":"changelog.html#various-fixes-improvements"},{"type":"extras","title":"10.0.3 - CHANGELOG","doc":"","ref":"changelog.html#10-0-3"},{"type":"extras","title":"Various fixes & improvements - CHANGELOG","doc":"- No \"app.config\" in \"mix sentry.package_source_code\" (#661) by @whatyouhide\n- Add upgrade guide links to the changelog (#659) by @axelson","ref":"changelog.html#various-fixes-improvements"},{"type":"extras","title":"10.0.2 - CHANGELOG","doc":"","ref":"changelog.html#10-0-2"},{"type":"extras","title":"Various fixes & improvements - CHANGELOG","doc":"- Fix infinite logging loop (#657) by @whatyouhide\n- Remove reference to \"before_send_event\" in README (f1650502) by @whatyouhide\n- Don't report events if DSN is not configured (#655) by @whatyouhide","ref":"changelog.html#various-fixes-improvements"},{"type":"extras","title":"10.0.1 - CHANGELOG","doc":"","ref":"changelog.html#10-0-1"},{"type":"extras","title":"Various fixes & improvements - CHANGELOG","doc":"- Fix reading of config in \"mix sentry.package_source_code\" (#653)\n- Don't ship Dialyzer PLTs with releases (#654)","ref":"changelog.html#various-fixes-improvements"},{"type":"extras","title":"10.0.0 - CHANGELOG","doc":"[9.x -> 10.0 Upgrade Guide](https://hexdocs.pm/sentry/upgrade-10-x.html)\n\n- `:report_deps` now reports all loaded applications at the time the `:sentry` application starts. This is not a compile-time configuration option anymore.\n- Add the `mix sentry.package_source_code` Mix task. See the upgrade guide for more information.\n- Add `~r\"/test/\"` to the default source code exclude patterns (see the `:source_code_exclude_patterns` option).\n- `:environment_name` now defaults to `production` (if it wasn't configured explicitly and if the `SENTRY_ENVIRONMENT` environment variable is not set).\n- Hard-deprecate `:included_environments`. To control whether to send events to Sentry, use the `:dsn` configuration option instead. `:included_environments` now emits a warning if used, but will still work until v11.0.0 of this library.\n- Hard-deprecate `:before_send_event` in favor of the new `:before_send`. This brings this SDK in line with all other Sentry SDKs.","ref":"changelog.html#10-0-0"},{"type":"extras","title":"9.1.0 - CHANGELOG","doc":"","ref":"changelog.html#9-1-0"},{"type":"extras","title":"Various fixes & improvements - CHANGELOG","doc":"- Attempt to scrub all `Plug.Conn`s in `Sentry.PlugCapture` (#619) by @whatyouhide\n- Fix typespec for the `Sentry.Context.t/0` type (#618) by @whatyouhide\n- Apply `:sample_rate` *after* event callbacks, rather than *before* (ab5c7485) by @whatyouhide","ref":"changelog.html#various-fixes-improvements"},{"type":"extras","title":"9.0.0 - CHANGELOG","doc":"[8.x -> 9.0 Upgrade Guide](https://hexdocs.pm/sentry/upgrade-9-x.html)","ref":"changelog.html#9-0-0"},{"type":"extras","title":"Breaking changes - CHANGELOG","doc":"- Removed `Sentry.Sources`\n- Removed `Sentry.Client`, as it's an internal module\n- Removed the `Sentry.Event.sentry_exception/0` type\n- Removed `Sentry.Event.add_metadata/1`\n- Removed `Sentry.Event.culprit_from_stacktrace/1`\n- Removed `Sentry.Event.do_put_source_context/3`\n- Removed the `:async` value for the `:result` option in `Sentry.send_event/2` (and friends)\n- Removed `Sentry.CrashError` — now, crash reports (detected through `Sentry.LoggerBackend`) that do not contain exceptions are reported as *messages* in Sentry\n- Changed the shape of the `Sentry.Event` struct - check out the new fields (and typespec for `Sentry.Event.t/0`)","ref":"changelog.html#breaking-changes"},{"type":"extras","title":"Various fixes & improvements - CHANGELOG","doc":"- Add `Sentry.LoggerHandler`, which is a `:logger` handler rather than a `Logger` backend\n- Make the `Sentry.HTTPClient.child_spec/0` callback optional\n- Add `:all` as a possible value of the `:metadata` configuration option for `Sentry.LoggerBackend`\n- Add `:all` as a possible value for the `:included_environment` configuration option\n- Add `Sentry.Interfaces` with all the child modules, which are useful if you're working directly with the Sentry API\n- Fix an issue with JSON-encoding non-encodable terms (such as PIDs, which are pretty common)","ref":"changelog.html#various-fixes-improvements"},{"type":"extras","title":"Deprecations - CHANGELOG","doc":"- Soft-deprecate `Sentry.EventFilter` in favour of `:before_send_event` callbacks.","ref":"changelog.html#deprecations"},{"type":"extras","title":"Various fixes & improvements - CHANGELOG","doc":"- Remove manually-entered entries from the CHANGELOG (48cf37d9) by @whatyouhide\n- Don't cover test/support in tests (8cfe14b1) by @whatyouhide\n- Make two more funs private in Sentry.Event (340ba143) by @whatyouhide\n- Add excoveralls for code coverage (58d94cf2) by @whatyouhide\n- Clean up Sentry.Config (f996c7d3) by @whatyouhide\n- Revert default :included_environments to [:prod] (d33bf19d) by @whatyouhide\n- Send async events right away without queueing (#612) by @whatyouhide\n- Make Sentry.Interfaces.Request a struct (#611) by @whatyouhide\n- Improve some tests (59e8ebb0) by @whatyouhide\n- Add Sentry logo to the docs (6d27eacf) by @whatyouhide\n- Polish docs for \"mix sentry.send_test_event\" (903aeb93) by @whatyouhide\n- Update changelog and error messages (f6f577f4) by @whatyouhide\n- Soft-deprecate Sentry.EventFilter (#608) by @whatyouhide\n- Improve Sentry.Event struct definition (#609) by @whatyouhide\n- Clean up docs and tests for \"mix sentry.send_test_event\" (#610) by @whatyouhide\n- Add Sentry.LoggerHandler (#607) by @whatyouhide\n- Remove Sentry.CrashError and improve EXIT reporting (#606) by @whatyouhide\n- Support :all in Sentry.LoggerBackend's :metadata (#605) by @whatyouhide\n- Optimize JSON sanitization step (b96d6cfd) by @whatyouhide\n- Accept all environments by default (#604) by @whatyouhide\n- Add example about alternative HTTP client to docs (38e80edf) by @whatyouhide\n- Make Sentry.HTTPClient.child_spec/0 optional (#603) by @whatyouhide\n- Clean up a bunch of little non-important things (18e83ae9) by @whatyouhide\n- Simplify test GenServer (30a9828e) by @whatyouhide","ref":"changelog.html#various-fixes-improvements"},{"type":"extras","title":"8.1.0 - CHANGELOG","doc":"","ref":"changelog.html#8-1-0"},{"type":"extras","title":"Various fixes & improvements - CHANGELOG","doc":"- Bump min craft version to 1.4.2 (795bfd12) by @sl0thentr0py\n- Add github target to craft (ef563cc5) by @sl0thentr0py\n- Bump min craft version (56516be2) by @sl0thentr0py\n- Improve deprecation of Sentry.Config.root_source_code_path/0 (#558) by @whatyouhide\n- Wrap HTTP requests in try/catch (#515) by @ruslandoga\n- Remove extra config files (#556) by @yordis\n- Remove use of deprecated Mix.Config (#555) by @whatyouhide\n- Add release/** branches to ci for craft (dfaffb9f) by @sl0thentr0py\n- Fix typo in moduledoc (#534) by @louisvisser\n- Check :hackney application when starting (#554) by @whatyouhide\n- feat(event): filter more exceptions by default (#550) by @gpouilloux\n- Fix example configuration for Sentry.Sources (#543) by @scudelletti\n- Use module attribute for dictionary key consistently (#537) by @tmecklem\n- Fix send_event/2 typespec (#545) by @ruslandoga\n- Update badges in the README (#548) by @ruslandoga\n- Update ex_docs to 0.29+ (#549) by @ruslandoga\n- Fix Elixir 1.15 warnings (#553) by @dustinfarris\n- Add :remote_address_reader PlugContext option (#519) by @michallepicki\n- Traverse full domain list when checking for excluded domains (#508) by @martosaur\n- Add craft with target hex (#532) by @sl0thentr0py\n- Add Sentry to LICENSE (#530) by @sl0thentr0py\n- Update ci setup-beam action name (#531) by @sl0thentr0py\n- allow logging from tasks (#517) by @ruslandoga\n- Improve DSN parsing and Endpoint building (#507) by @AtjonTV\n\n_Plus 14 more_","ref":"changelog.html#various-fixes-improvements"},{"type":"extras","title":"8.0.6 (2021-09-28) - CHANGELOG","doc":"* Bug Fixes\n  * Remove function that disables non-group leader logging (#467)\n  * Handle :unsampled events in `Sentry.send_test_event` (#474)\n  * Fix dialyzer reporting unmatched\\_return for Sentry.PlugCapture (#475)\n  * Use correct `Plug.Parsers` exception module (#482)","ref":"changelog.html#8-0-6-2021-09-28"},{"type":"extras","title":"8.0.5 (2021-02-14) - CHANGELOG","doc":"* Enhancements\n  * Support lists in scrubbing (#442)\n  * Send Sentry reports on uncaught throws/exits (#447)\n\n* Bug Fixes\n  * Deprecate `Sentry.Config.in_app_module_whitelist` in favor of `Sentry.Config.in_app_module_allow_list` (#450)\n  * Update outdated `Sentry.Plug` documentation (#452)\n  * Update `Sentry.HTTPClient` documentation (#456)","ref":"changelog.html#8-0-5-2021-02-14"},{"type":"extras","title":"8.0.4 (2020-11-16) - CHANGELOG","doc":"* Bug Fixes\n  * Do not read DSN config at compile time (#441)","ref":"changelog.html#8-0-4-2020-11-16"},{"type":"extras","title":"8.0.3 (2020-11-11) - CHANGELOG","doc":"* Enhancements\n  * Update package & docs configuration (#432)\n  * Add Plug.Status filter example (#433)\n  * Support multiple source code root paths in Sentry.Sources (#437)\n\n* Bug Fixes\n  * Fix dialyzer reporting unmatched_return for Sentry.PlugCapture (#436)\n  * Align Sentry event levels with Elixir logging levels (#439)","ref":"changelog.html#8-0-3-2020-11-11"},{"type":"extras","title":"8.0.2 (2020-09-06) - CHANGELOG","doc":"* Enhancements\n  * Log error when JSON is unencodable (#429)\n  * Set logger event level to logger message level (#430)\n  * Limit breadcrumbs on add_breadcrumb (#431)","ref":"changelog.html#8-0-2-2020-09-06"},{"type":"extras","title":"8.0.1 (2020-08-08) - CHANGELOG","doc":"* Enhancements\n  * Add plug parsing errors to list of default excluded params (#414)\n  * Make Sentry.PlugContext.scrub\\_map public (#417)\n  * Allow users to configure maximum number of breadcrumbs (#418)","ref":"changelog.html#8-0-1-2020-08-08"},{"type":"extras","title":"8.0.0 (2020-07-13) - CHANGELOG","doc":"[7.x -> 8.0 Upgrade Guide](https://gist.github.com/mitchellhenke/dce120a5515565076b13962ee0be749b)\n\n* Bug Fixes\n  * Fix documentation for `Sentry.PlugContext` (#410)","ref":"changelog.html#8-0-0-2020-07-13"},{"type":"extras","title":"8.0.0-rc.2 (2020-07-01) - CHANGELOG","doc":"* Bug Fixes\n  * Fix trying to transform erlang error coming from PlugCapture (#406)","ref":"changelog.html#8-0-0-rc-2-2020-07-01"},{"type":"extras","title":"8.0.0-rc.1 (2020-06-29) - CHANGELOG","doc":"* Bug Fixes\n  * Remove changes that were unintentionally included in build","ref":"changelog.html#8-0-0-rc-1-2020-06-29"},{"type":"extras","title":"8.0.0-rc.0 (2020-06-24) - CHANGELOG","doc":"* Enhancements\n  * Cache environment config in application config (#393)\n  * Allow configuring LoggerBackend to send all messages, not just exceptions (e.g. `Logger.error(\"I am an error message\")`)\n\n* Bug Fixes\n  * fix request url port in payloads for HTTPS requests  (#391)\n\n* Breaking Changes\n  * Change default `included_environments` to only include `:prod` by default (#370)\n  * Change default event send type to :none instead of :async (#341)\n  * Make hackney an optional dependency, and simplify Sentry.HTTPClient behaviour (#400)\n  * Use Logger.metadata for Sentry.Context, no longer return metadata values on set_* functions, and rename `set_http_context` to `set_request_context` (#401)\n  * Move excluded exceptions from Sentry.Plug to Sentry.DefaultEventFilter (#402)\n  * Remove Sentry.Plug and Sentry.Phoenix.Endpoint in favor of Sentry.PlugContext and Sentry.PlugCapture (#402)\n  * Remove feedback form rendering and configuration (#402)\n  * Logger metadata is now specified by key in LoggerBackend instead of enabled/disabled (#403)\n  * Require Elixir 1.10 and optionally plug_cowboy 2.3 (#403)\n  * `Sentry.capture_exception/1` now only accepts exceptions (#403)","ref":"changelog.html#8-0-0-rc-0-2020-06-24"},{"type":"extras","title":"7.2.4 (2020-03-09) - CHANGELOG","doc":"* Enhancements\n  * Allow configuring gather feedback form for Sentry.Plug errors (#387)","ref":"changelog.html#7-2-4-2020-03-09"},{"type":"extras","title":"7.2.3 (2020-02-27) - CHANGELOG","doc":"* Enhancements\n  * Allow gathering feedback from Sentry.Plug errors (#385)","ref":"changelog.html#7-2-3-2020-02-27"},{"type":"extras","title":"7.2.2 (2020-02-13) - CHANGELOG","doc":"* Bug Fixes\n  * Ensure stacktrace is list in LoggerBackend (#380)","ref":"changelog.html#7-2-2-2020-02-13"},{"type":"extras","title":"7.2.1 (2019-12-05) - CHANGELOG","doc":"* Bug Fixes\n  * Improve documentation for `Sentry.Client.send_event/2` (#367)\n  * Fix potential Logger deadlock (#372)\n  * Pass the same exception for NoRouteError in `Sentry.Phoenix.Endpoint` (#376)\n  * Handle new MFA for duplicate Plug errors (#377)\n  * Update docs to recommend using application environment config for adding `Sentry.LoggerBackend` (#379)","ref":"changelog.html#7-2-1-2019-12-05"},{"type":"extras","title":"7.2.0 (2019-10-23) - CHANGELOG","doc":"* Enhancements\n  * Allow filtering of Events using `before_send_event` (#364)\n\n* Bug Fixes\n  * Remove newline from Logger for API error (#351)\n  * Add docs for Sentry.Context (#352)\n  * Avoid error duplication for Plug errors (#355)\n  * Fix issue in Sentry.Sources docs around recompilation (#357)","ref":"changelog.html#7-2-0-2019-10-23"},{"type":"extras","title":"7.1.0 (2019-06-11) - CHANGELOG","doc":"* Enhancements\n  * Option to include `Logger.metadata` in `Sentry.LoggerBackend` (#338)\n  * Send maximum length of args in stacktrace (#340)\n  * Fix dialyzer warning when using Sentry.Phoenix.Endpoint (#344)\n\n* Bug Fixes\n  * Fix documentation error relating to File.cwd!() (#346)\n  * Add parens to File.cwd!() in documentation (#347)\n  * Check that DSN is binary (#348)","ref":"changelog.html#7-1-0-2019-06-11"},{"type":"extras","title":"7.0.6 (2019-04-17) - CHANGELOG","doc":"* Enhancements\n  * Allow configuring Sentry log level (#334)","ref":"changelog.html#7-0-6-2019-04-17"},{"type":"extras","title":"7.0.5 (2019-04-05) - CHANGELOG","doc":"* Bug Fixes\n  * Strip leading \"Elixir.\" from module name on error type (#330)","ref":"changelog.html#7-0-5-2019-04-05"},{"type":"extras","title":"7.0.4 (2019-02-12) - CHANGELOG","doc":"* Bug Fixes\n  * Do not error if you cannot format the remote IP or port (#326)","ref":"changelog.html#7-0-4-2019-02-12"},{"type":"extras","title":"7.0.3 (2018-11-14) - CHANGELOG","doc":"* Bug Fixes\n  * Fix issue from using spawn\\_link stacktrace (#315)\n  * Relax plug\\_cowboy versions (#314)","ref":"changelog.html#7-0-3-2018-11-14"},{"type":"extras","title":"7.0.2 (2018-11-01) - CHANGELOG","doc":"* Bug Fixes\n  * Fix sending Phoenix.Router.NoRouteError when using Sentry.Phoenix.Endpoint (#309)","ref":"changelog.html#7-0-2-2018-11-01"},{"type":"extras","title":"7.0.1 (2018-10-01) - CHANGELOG","doc":"* Enhancements\n  * Remove Poison from applications list (#306)","ref":"changelog.html#7-0-1-2018-10-01"},{"type":"extras","title":"7.0.0 (2018-09-07) - CHANGELOG","doc":"* Enhancements\n  * Implement `Sentry.LoggerBackend`\n\n* Breaking Changes\n  * Replace Poison with configurable JSON library\n  * Require Elixir 1.7+\n  * Remove `Sentry.Logger`","ref":"changelog.html#7-0-0-2018-09-07"},{"type":"extras","title":"6.4.2 (2018-09-05) - CHANGELOG","doc":"* Enhancements\n  * Add deps reporting back (#305 / #301)","ref":"changelog.html#6-4-2-2018-09-05"},{"type":"extras","title":"6.4.1 (2018-07-26) - CHANGELOG","doc":"* Bug Fixes\n  * Remove UUID dependency (#298)\n  * Fix link in documentation (#300)","ref":"changelog.html#6-4-1-2018-07-26"},{"type":"extras","title":"6.4.0 (2018-07-02) - CHANGELOG","doc":"* Enhancements\n  * Add documentation detail around including source code (#287)\n  * Document fingerprinting (#288)\n  * Document `Sentry.Context` (#289)\n  * Add CONTRIBUTING.md (#290)\n  * Document cookie scrubber (#291)\n  * Document testing with Sentry (#292)\n\n* Bug Fixes\n  * Change `report_deps` default value to false to avoid compiler bug (#285)\n  * Limit size of messages (#293)\n  * Use `elixir_uuid` instead of `uuid` (#295)","ref":"changelog.html#6-4-0-2018-07-02"},{"type":"extras","title":"6.3.0 (2018-06-26) - CHANGELOG","doc":"* Enhancements\n  * Use the stacktrace passed to Sentry.Event.transform_exception/2 when calling Exception.normalize/3 (#266)\n  * Reduce Logger noise in HTTP Client (#274)\n  * Use `Plug.Conn.get_peer_data/1` (#273)\n\n* Bug Fixes\n  * Add documentation for capturing arbitrary events (#272)\n  * Fix typo in README.md (#277)","ref":"changelog.html#6-3-0-2018-06-26"},{"type":"extras","title":"6.2.1 (2018-04-24) - CHANGELOG","doc":"* Enhancements\n  * Accept public key DSNs (#263)","ref":"changelog.html#6-2-1-2018-04-24"},{"type":"extras","title":"6.2.0 (2018-04-04) - CHANGELOG","doc":"* Enhancements\n  * Allow overriding in Sentry.Plug (#261)\n  * Implement Sentry.Phoenix.Endpoint to capture errors in Phoenix.Endpoint (#259)\n* Bug Fixes\n  * Fix sending events from remote\\_console (#262)\n  * Add filter option to configuration table in README (#255)\n  * Default to not sending cookies, but allow configuration to send (#254)\n  * Do not raise on invalid DSN (#218)","ref":"changelog.html#6-2-0-2018-04-04"},{"type":"extras","title":"6.1.0 (2017-12-07) - CHANGELOG","doc":"* Enhancements\n  * Elixir 1.6.0 formatted (#246)\n  * Improve documentation around source code compilation (#242)\n  * Update typespecs (#249)\n  * Report errors from :kernel.spawn processes (#251)\n* Bug Fixes\n  * Fix doc typos (#245)\n  * Remove Sentry.Event compile warning (#248)\n  * Fix enable\\_source\\_code\\_context configuration (#247)","ref":"changelog.html#6-1-0-2017-12-07"},{"type":"extras","title":"6.0.5 (2017-12-07) - CHANGELOG","doc":"* Enhancements\n  * Improve README documentation (#236)\n  * Fix GenEvent warning (#237, #239)\n* Bug Fixes\n  * Fix error\\_type reported in Sentry.Plug (#238)","ref":"changelog.html#6-0-5-2017-12-07"},{"type":"extras","title":"6.0.4 (2017-11-20) - CHANGELOG","doc":"* Enhancements\n  * Allow string for included_environments by splitting on commas (#234)\n* Bug Fixes\n  * Handle :error when sending test event (#228)","ref":"changelog.html#6-0-4-2017-11-20"},{"type":"extras","title":"6.0.3 (2017-11-01) - CHANGELOG","doc":"* Enhancements\n  * Fix tests for differing versions of Erlang/Elixir (#221)\n* Bug Fixes\n  * Fix invalid value for stacktrace via Event rendering layer (#224)","ref":"changelog.html#6-0-3-2017-11-01"},{"type":"extras","title":"6.0.2 (2017-10-03) - CHANGELOG","doc":"* Enhancements\n  * Improve Sentry.Logger documentation (#217)\n* Bug Fixes\n  * Handle Plug.Upload during scrubbing (#208)\n  * Do not check DSN for source\\_code\\_path_pattern configuration (#211)\n  * Fix culprit ambiguity (#214)","ref":"changelog.html#6-0-2-2017-10-03"},{"type":"extras","title":"6.0.1 (2017-09-06) - CHANGELOG","doc":"* Bug Fixes\n  * Fix filters and test mix task (#206)\n* Enhancements\n  * Improve README clarity (#202)","ref":"changelog.html#6-0-1-2017-09-06"},{"type":"extras","title":"6.0.0 (2017-08-29) - CHANGELOG","doc":"See these [`5.0.0` to `6.0.0` upgrade instructions](https://gist.github.com/mitchellhenke/ffe2048e708fd7dd32d8d0a843daddf3) to update your existing app.\n\n* Breaking Changes\n  * Remove use\\_error\\_logger configuration (#196)\n  * enable\\_source\\_code\\_context is no longer required configuration (#201)\n* Bug Fixes\n  * Fix README error (#197)\n  * Prevent overwriting server\\_name option (#200)\n* Enhancements\n  * Scrubbing of nested maps (#192)\n  * Allow Hackney 1.9 and later (#199)","ref":"changelog.html#6-0-0-2017-08-29"},{"type":"extras","title":"5.0.1 (2017-07-18) - CHANGELOG","doc":"* Bug Fixes\n  * Fix logger and context usage (#185)","ref":"changelog.html#5-0-1-2017-07-18"},{"type":"extras","title":"5.0.0 (2017-07-10) - CHANGELOG","doc":"* Backward incompatible changes\n  * Allow specifying sync/async/none when getting result of sending event (#174)\n* Enhancements\n  * Modules (#182)\n  * Config from system and DSN (#180)\n  * App Frames (#177)\n  * Sampling (#176)\n  * Post event hook (#175)\n  * Improve documentation around recompilation for source code context (#171)\n  * Use better arity logic in stacktraces (#170)\n  * Allow custom fingerprinting (#160)\n* Bug Fixes\n  * Fix README typo (#159)\n  * Fix the backoff to really be exponential (#162)","ref":"changelog.html#5-0-0-2017-07-10"},{"type":"extras","title":"4.0.3 (2017-05-17) - CHANGELOG","doc":"* Enhancements\n  * Update and improve Travis build matrix (#155)\n  * Specify behaviour for Sentry HTTP clients (#158)","ref":"changelog.html#4-0-3-2017-05-17"},{"type":"extras","title":"4.0.2 (2017-04-26) - CHANGELOG","doc":"* Enhancements\n  * Relax hackney requirements","ref":"changelog.html#4-0-2-2017-04-26"},{"type":"extras","title":"4.0.1 (2017-04-25) - CHANGELOG","doc":"* Enhancements\n  * Bump hackney to a version that fixes major bug (#153)","ref":"changelog.html#4-0-1-2017-04-25"},{"type":"extras","title":"4.0.0 (2017-04-20) - CHANGELOG","doc":"See these [`3.0.0` to `4.0.0` upgrade instructions](https://gist.github.com/mitchellhenke/5248b3073f113309fa25550a0e4126d4) to update your existing app.\n\n* Enhancements\n  * Bump hackney to a version that isn't retired (#135)\n  * Improve Logger reporting (#136)\n  * Accept keyword lists in `Sentry.Context.add_breadcrumb/1` (#139)\n  * Add elements to beginning of breadcrumbs list for performance (#141)\n  * Close unread hackney responses properly (#149)\n  * Improve `Sentry.Client` code style (#147)\n  * Fix invalid specs in `Sentry` methods (#146)\n  * Allow setting client at runtime (#150)\n* Backward incompatible changes\n  * Return `:ignored` instead of `{:ok, \"\"}` when event is not sent because environment\\_name is not in included\\_environments in `Sentry.send_event`, `Sentry.capture_exception`, or `Sentry.capture_message` (#146)\n  * Return `:ignored` and log warning instead of returning `{:ok, \"Sentry: unable to parse exception\"}` when unable to parse exception in `Sentry.send_event`, `Sentry.capture_exception`, or `Sentry.capture_message` (#146)\n  * Return `{:ok, Task}` instead of `Task` when an event is successfully sent with `Sentry.send_event`, `Sentry.capture_exception`, or `Sentry.capture_message` (#146)\n  * Ignore non-existent route exceptions (#110)\n  * Sending source code as context when reporting errors (#138)","ref":"changelog.html#4-0-0-2017-04-20"},{"type":"extras","title":"3.0.0 (2017-03-02) - CHANGELOG","doc":"* Enhancements\n  * Add dialyzer support (#128)\n* Backward incompatible changes\n  * Fix default configuration (#124)\n  * Start and use separate Sentry hackney pool instead of default (#130)\n  * Return `:error` instead of raising when encoding invalid JSON (#131)","ref":"changelog.html#3-0-0-2017-03-02"},{"type":"extras","title":"2.2.0 (2017-02-15) - CHANGELOG","doc":"* Enhancements\n  * Allow setting `hackney_opts`\n  * Add `Sentry.capture_message/1`\n  * Allow reading `:dsn` from System at runtime by configuring as `{:system, \"ENV_VAR\"}`","ref":"changelog.html#2-2-0-2017-02-15"},{"type":"extras","title":"2.1.0 (2016-12-17) - CHANGELOG","doc":"* Enhancements\n  * Allow filtering which exceptions are sent via `Sentry.EventFilter` behaviour\n  * Add `Sentry.Context.set_http_context/1`\n\n* Bug Fixes\n  * Fix usage of deprecated modules\n  * Fix README documentation\n  * Fix timestamp parameter format","ref":"changelog.html#2-1-0-2016-12-17"},{"type":"extras","title":"2.0.2 (2016-12-08) - CHANGELOG","doc":"* Bug Fixes\n  * Fix regex checking of non-binary values","ref":"changelog.html#2-0-2-2016-12-08"},{"type":"extras","title":"2.0.1 (2016-12-05) - CHANGELOG","doc":"* Bug Fixes\n  * Fix compilation error when Plug is not available","ref":"changelog.html#2-0-1-2016-12-05"},{"type":"extras","title":"2.0.0 (2016-11-28) - CHANGELOG","doc":"* Enhancements\n  * Return a task when sending a Sentry event\n  * Provide default scrubber for request body and headers (`Sentry.Plug.default_body_scrubber` and `Sentry.Plug.default_header_scrubber`)\n  * Header scrubbing can now be configured with `:header_scrubber`\n\n* Bug Fixes\n  * Ensure `mix sentry.send_test_event` finishes sending event before ending Mix task\n\n* Backward incompatible changes\n  * `Sentry.capture_exception/1` now returns a `Task` instead of `{:ok, PID}`\n  * Sentry.Plug `:scrubber` option has been removed in favor of the more descriptive `:body_scrubber`option, which defaults to newly added `Sentry.Plug.default_scrubber/1`\n  * New option for Sentry.Plug `:header_scrubber` defaults to newly added `Sentry.Plug.default_header_scrubber/1`\n  * Request bodies were not previously sent by default.  Because of above change, request bodies are now sent by default after being scrubbed by default scrubber.  To prevent sending any data, `:body_scrubber` should be set to `nil`","ref":"changelog.html#2-0-0-2016-11-28"},{"type":"extras","title":"Setup with Plug and Phoenix","doc":"# Setup with Plug and Phoenix\n\nYou can enrich errors in Plug (and Phoenix) applications with `Sentry.PlugContext`. `Sentry.PlugContext` adds contextual metadata from the current request which is then included in errors.","ref":"setup-with-plug-and-phoenix.html"},{"type":"extras","title":"For Phoenix Applications - Setup with Plug and Phoenix","doc":"If you are using Phoenix:\n\n  1. Add `Sentry.PlugContext` below `Plug.Parsers`\n\n```diff\n defmodule MyAppWeb.Endpoint\n   use Phoenix.Endpoint, otp_app: :my_app\n\n   # ...\n\n   plug Plug.Parsers,\n     parsers: [:urlencoded, :multipart, :json],\n     pass: [\"*/*\"],\n     json_decoder: Phoenix.json_library()\n\n+  plug Sentry.PlugContext\n```\n\n  1. If you're using Cowboy, also add `Sentry.PlugCapture` above the `use Phoenix.Endpoint` line in your endpoint file\n  \n```diff\n defmodule MyAppWeb.Endpoint\n+  use Sentry.PlugCapture\n   use Phoenix.Endpoint, otp_app: :my_app\n\n   # ...\n```\n\nIf you're also using [Phoenix LiveView](https://github.com/phoenixframework/phoenix_live_view), consider also setting up your LiveViews to use the `Sentry.LiveViewHook` hook:\n\n```elixir\ndefmodule MyAppWeb do\n  def live_view do\n    quote do\n      use Phoenix.LiveView\n\n      on_mount Sentry.LiveViewHook\n    end\n  end\nend\n```","ref":"setup-with-plug-and-phoenix.html#for-phoenix-applications"},{"type":"extras","title":"Capturing User Feedback - Setup with Plug and Phoenix","doc":"If you would like to capture user feedback as described [here](https://docs.sentry.io/platforms/elixir/enriching-events/user-feedback/), the `Sentry.get_last_event_id_and_source/0` function can be used to see if Sentry has sent an event within the current Plug process (and get the source of that event). `:plug` will be the source for events coming from `Sentry.PlugCapture`. The options described in the Sentry documentation linked above can be encoded into the response as well.\n\nAn example Phoenix application setup that displays the user feedback form on 500 responses on requests accepting HTML could look like this:\n\n```elixir\ndefmodule MyAppWeb.ErrorView do\n  # ...\n\n  def render(\"500.html\", _assigns) do\n    case Sentry.get_last_event_id_and_source() do\n      {event_id, :plug} when is_binary(event_id) ->\n        opts = JSON.encode!(%{eventId: event_id})\n\n        ~E\"\"\"\n            \n           \n            Sentry.init({ dsn: '<%= Sentry.Config.dsn() %>' });\n            Sentry.showReportDialog(<%= raw opts %>)\n           \n        \"\"\"\n\n      _ ->\n        \"Error\"\n    end\n  end\nend\n```","ref":"setup-with-plug-and-phoenix.html#capturing-user-feedback"},{"type":"extras","title":"For Plug Applications - Setup with Plug and Phoenix","doc":"If you are in a non-Phoenix Plug application:\n\n  1. Add `Sentry.PlugContext` below `Plug.Parsers` (if it is in your stack)\n\n```diff\n defmodule MyApp.Router do\n   use Plug.Router\n\n   # ...\n\n   plug Plug.Parsers,\n     parsers: [:urlencoded, :multipart]\n\n+  plug Sentry.PlugContext\n```\n\n  1. If you're using Cowboy, add `Sentry.PlugCapture` at the top of your Plug application\n\n```diff\n defmodule MyApp.Router do\n   use Plug.Router\n+  use Sentry.PlugCapture\n\n   # ...\n```","ref":"setup-with-plug-and-phoenix.html#for-plug-applications"},{"type":"extras","title":"Oban Integration","doc":"# Oban Integration\n\nThe Sentry SDK supports integrating with [Oban](https://github.com/sorentwo/oban), one of the most widely-used job-scheduling libraries in the Elixir ecosystem.\n\nFor documentation and setup instructions, see the [Sentry website](https://docs.sentry.io/platforms/elixir/integrations/oban/).","ref":"oban-integration.html"},{"type":"extras","title":"Quantum Integration","doc":"# Quantum Integration\n\nThe Sentry SDK supports integrating with [Quantum](https://github.com/quantum-elixir/quantum-core), a popular Elixir library for scheduling cron jobs.\n\nFor documentation and setup instructions, see the [Sentry website](https://docs.sentry.io/platforms/elixir/integrations/quantum/).","ref":"quantum-integration.html"},{"type":"extras","title":"Telemetry Integration","doc":"# Telemetry Integration\n\nThe Sentry SDK supports integrating with [Telemetry](https://github.com/beam-telemetry/telemetry).\n\nFor documentation and setup instructions, see the [Sentry website](https://docs.sentry.io/platforms/elixir/integrations/telemetry/).","ref":"telemetry-integration.html"},{"type":"extras","title":"Upgrade to Sentry 8.x","doc":"# Upgrade to Sentry 8.x\n\nSentry 8.x requires Elixir 1.10 and Sentry 7.x will be maintained for applications running prior versions. Documentation for Sentry 7.x can be found [here](https://hexdocs.pm/sentry/7.2.4/readme.html).\n\nIf you would like to upgrade a project to use Sentry 8.x, see [here](https://gist.github.com/mitchellhenke/dce120a5515565076b13962ee0be749b).","ref":"upgrade-8-x.html"},{"type":"extras","title":"Upgrade to Sentry 9.x","doc":"# Upgrade to Sentry 9.x\n\nThis guide contains information on how to upgrade from Sentry 8.x to Sentry 9.x. If you're on a version lower than 8.x, see the previous upgrade guides to get to 8.x before going through this one.","ref":"upgrade-9-x.html"},{"type":"extras","title":"Check Your Elixir Version - Upgrade to Sentry 9.x","doc":"Sentry 9.0.0 requires Elixir 1.11+. If you're still running on Elixir 1.10 or lower, use Sentry 8.x or lower.","ref":"upgrade-9-x.html#check-your-elixir-version"},{"type":"extras","title":"Remove DSN Query Params - Upgrade to Sentry 9.x","doc":"Before 9.0.0, the Sentry Elixir library supported one way of passing configuration through **query parameters** in the configured Sentry DSN. This is **not supported** anymore in 9.0.0.\n\nTo upgrade:\n\n  1. Remove query parameters from your configured Sentry DSN.\n  1. Set the values for those parameters as normal configuration, either via the application environment, or via environment variables.\n\nFor example:\n\n```elixir\n# In config/config.exs\n\n# Replace this:\nconfig :sentry,\n  dsn: \"https://public:secret@app.getsentry.com/1?server_name=my-server\"\n\n# with this:\nconfig :sentry,\n  dsn: \"https://public:secret@app.getsentry.com/1\",\n  server_name: \"my-server\"\n```","ref":"upgrade-9-x.html#remove-dsn-query-params"},{"type":"extras","title":"Make Sure the Environment Name Is Configured - Upgrade to Sentry 9.x","doc":"Sentry now requires the `:environment_name` configuration to be set, since the default was causing potential issues (such as [#524](https://github.com/getsentry/sentry-elixir/issues/524)). To fix this, configure `:environment_name` or set the `SENTRY_ENVIRONMENT` system environment variable.","ref":"upgrade-9-x.html#make-sure-the-environment-name-is-configured"},{"type":"extras","title":"Fix Your Environment Variables - Upgrade to Sentry 9.x","doc":"Sentry 9.0.0 stops using many \"magic\" system environment variables for configuration. These were environment variables prefixed with `SENTRY_`.\n\nIf you were using these environment variables, you'll either need to configure the corresponding setting through the application environment, or you'll need to *read* those variables yourself (at **runtime**).\n\nFor example, if you were setting `SENTRY_LOG_LEVEL`, you'll have to do something like:\n\n```elixir\n# In config/runtime.exs\nconfig :sentry,\n  log_level: System.fetch_env!(\"SENTRY_LOG_LEVEL\")\n```\n\nWe strongly recommend you do this in `config/runtime.exs` so that you'll read the system environment when starting your application. This is going to work both for local development as well as in [Mix releases](https://hexdocs.pm/mix/1.15.4/Mix.Tasks.Release.html).\n\nThis is the new system environment variables configuration:\n\n| System environment variable | Corresponding configuration setting | Supported in 9.0.0+           |\n| --------------------------- | ----------------------------------- | ----------------------------- |\n| `SENTRY_SERVER_NAME`        | `:server_name`                      | ❌                            |\n| `SENTRY_LOG_LEVEL`          | `:log_level`                        | ❌                            |\n| `SENTRY_CONTEXT_LINES`      | `:context_lines`                    | ❌                            |\n| `SENTRY_ENVIRONMENT_NAME`   | `:environment_name`                 | ❌ — use `SENTRY_ENVIRONMENT` |\n| `SENTRY_ENVIRONMENT`        | `:environment_name`                 | ✅                            |\n| `SENTRY_DSN`                | `:dsn`                              | ✅                            |\n| `SENTRY_RELEASE`            | `:release`                          | ✅                            |","ref":"upgrade-9-x.html#fix-your-environment-variables"},{"type":"extras","title":"Stop Using `{:system, var}` - Upgrade to Sentry 9.x","doc":"Sentry used to support setting configuration options to `{:system, var}` in order to read `var` from the system environment at runtime. This behavior was there to compensate for releases before [Mix releases](https://hexdocs.pm/mix/1.15.4/Mix.Tasks.Release.html) were introduced.\n\nWith Mix releases, you can use `config/runtime.exs` to have runtime configuration that works both within releases and using Mix (like during local development).\n\nTo fix this, remove all the `{:system, var}` values from the Sentry configuration, move those options to `config/runtime.exs`, and use normal `System` functions to read the environment (such as `System.fetch_env!/1`).\n\n```elixir\n# Before, in config/config.exs ❌\nconfig :sentry,\n  # ...,\n  environment_name: {:system, \"SENTRY_ENV\"}\n\n# Now, in config/runtime.exs ✅\nconfig :sentry,\n  # ...,\n  environment_name: System.fetch_env!(\"SENTRY_ENV\")\n```","ref":"upgrade-9-x.html#stop-using-system-var"},{"type":"extras","title":"Fix Compile-Time Configuration - Upgrade to Sentry 9.x","doc":"Some configuration settings that Sentry supports are needed to **compile** Sentry itself. Before 9.0.0, you could change the value of these settings (such as `:enable_source_code_context`) at runtime, but it would have no effect. It would only do something if you were to change the value at compile time, and then you'd *recompile* Sentry itself.\n\nElixir v1.10.0 introduced [`Application.compile_env/2`](https://hexdocs.pm/elixir/1.15.4/Application.html#compile_env/2) however. This means that we were able to turn those settings into explicit *compile-time settings*. If you change the value of any of these settings now and forget to recompile Sentry, Mix will yell at you.\n\nThe fix for this is simple: do what Mix says.\n\nThe settings that are now *compile-time settings* are:\n\n  * `:enable_source_code_context`\n  * `:root_source_code_paths`\n  * `:report_deps`\n  * `:source_code_path_pattern`\n  * `:source_code_exclude_patterns`","ref":"upgrade-9-x.html#fix-compile-time-configuration"},{"type":"extras","title":"Stop Using `Sentry.Sources` - Upgrade to Sentry 9.x","doc":"`Sentry.Sources` was meant to be private API and has been removed. Its functionality is very specific to Sentry, and it's not a good general mechanism to retrieve source code. This way, we can also have the freedom to improve this functionality without making potential breaking changes to the API of this library.","ref":"upgrade-9-x.html#stop-using-sentry-sources"},{"type":"extras","title":"Stop Using `Sentry.Client` - Upgrade to Sentry 9.x","doc":"Most of the functionality that you could find in `Sentry.Client` was also available in the `Sentry` module. Additionally, most of the functions within `Sentry.Client` were not really usable in a generic way without deep knowledge of this library and the Sentry ecosystem.","ref":"upgrade-9-x.html#stop-using-sentry-client"},{"type":"extras","title":"Stop Using `result: :async` - Upgrade to Sentry 9.x","doc":"We removed the `:async` possible value from the `:result` option of `Sentry.Client.send_event/2`. Instead, you can spawn a task yourself.\n\nIf you had something like this before:\n\n```elixir\n{:ok, sentry_task} = Sentry.capture_exception(my_exception, result: :async)\n\n# Do other stuff...\n\nTask.await(sentry_task)\n```\n\nyou can now replace it with something like:\n\n```elixir\n# Start a supervisor for this somewhere, maybe in your application's\n# start/2 callback.\n{:ok, _} = Task.Supervisor.start_link(name: SentryAsyncSupervisor)\n\n{:ok, sentry_task} =\n  Task.Supervisor.async_nolink(SentryAsyncSupervisor, fn ->\n    Sentry.capture_exception(my_exception, result: :async)\n  end)\n\n# Do other stuff...\n\nTask.await(sentry_task)\n```","ref":"upgrade-9-x.html#stop-using-result-async"},{"type":"extras","title":"Upgrade to Sentry 10.x","doc":"# Upgrade to Sentry 10.x\n\nThis guide contains information on how to upgrade from Sentry `9.x` to Sentry `10.x`. If you're on a version lower than `9.x`, see the previous upgrade guides to get to `9.x` before going through this one.","ref":"upgrade-10-x.html"},{"type":"extras","title":"Actively Package Your Source Code - Upgrade to Sentry 10.x","doc":"Before Sentry `10.0.0`, in order to report source code context around errors you had to configure Sentry through the `:enable_source_code_context`, `:root_source_code_paths`, and a few other options. These were **compile-time options**, meaning that if you changed any of these you had to recompile *the Sentry dependency itself*, not just your project. This was because Sentry used to store the raw source code of your application in its own compiled bytecode.\n\nIn Sentry `10.0.0`, we've revised this approach for a couple of reasons:\n\n  * To avoid storing the raw source code in the compiled Sentry code, which in turn makes the BEAM bytecode artifact of your release smaller.\n\n  * To simplify the compilation/recompilation step mentioned above.\n\nNow, packaging source code is an active step that you have to take. The [`mix sentry.package_source_code`](`Mix.Tasks.Sentry.PackageSourceCode`) Mix task stores the source code in a compressed file inside the `priv` directory of the `:sentry` application. Sentry then loads this file when the `:sentry` application starts. This approach works well because users of Sentry are not interested in packaging source code within non-production environments, so this new task can be added to release scripts (or `Dockerfile`s, for example) only in production environments.\n\n*All the configuration options related to source code remain the same*. See [the documentation in the `Sentry` module](Sentry.html#module-reporting-source-code).","ref":"upgrade-10-x.html#actively-package-your-source-code"},{"type":"extras","title":"What Do I Have to Do? - Upgrade to Sentry 10.x","doc":"1. Add a call to `mix sentry.package_source_code` in your release script. This can be inside a `Dockerfile`, for example. Make sure to call this **before** `mix release`, so that the built release will include the packaged source code.\n\n  1. That's all!","ref":"upgrade-10-x.html#what-do-i-have-to-do"},{"type":"extras","title":"Make Sure You're Using the Right Environment - Upgrade to Sentry 10.x","doc":"Now, if you're not explicitly setting he `:environment_name` option in your config or setting the `SENTRY_ENVIRONMENT` environment variable, the environment will default to `production` (which is in line with the other Sentry SDKs).","ref":"upgrade-10-x.html#make-sure-you-re-using-the-right-environment"},{"type":"extras","title":"Rename `:before_send_event` to `:before_send` - Upgrade to Sentry 10.x","doc":"To be in line with all other Sentry SDKs, we renamed the `:before_send_event` configuration option to `:before_send`. Just rename `:before_send_event` to `:before_send` in your configuration and potentially in any call where you pass it directly.","ref":"upgrade-10-x.html#rename-before_send_event-to-before_send"},{"type":"extras","title":"Stop Using `:included_environments` - Upgrade to Sentry 10.x","doc":"We hard-deprecated `:included_environments`. It's a bit of a confusing option that essentially no other Sentry SDKs use. To control whether to send events to Sentry, use the `:dsn` configuration instead (if set then we send events, if not set then we don't send events). `:included_environments` will be removed in v11.0.0.\n\nFor example, if you had something like this in `config/config.exs`:\n\n```elixir\n# In config/config.exs\nconfig :sentry,\n  dsn: \"...\",\n  environment_name: config_env(),\n  included_environments: [:prod]\n```\n\nMove this block to `config/prod.exs`, and turn it into:\n\n```elixir\n# In config/prod.exs\nconfig :sentry,\n  dsn: \"...\",\n  environment_name: :prod\n```\n\nThis way, `:dsn` will only be set in the `:prod` environment and no events will be sent in the development or testing environments.\n\nAlternatively, if you were setting `:dsn` in `config/runtime.exs` (for use with Mix releases), change it to:\n\n```elixir\n# In config/runtime.exs\nif config_env() == :prod do\n  config :sentry,\n    dsn: \"...\",\n    environment_name: :prod\nend\n```","ref":"upgrade-10-x.html#stop-using-included_environments"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}